// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef __OB_GroupORT_impl_h__
#define __OB_GroupORT_impl_h__

#include <OB/ValueBase.h>
#include <OB/ValueFactoryBase.h>

#include <GroupORT.h>

//
// IDL:ooc.com/LoadBalancing:1.0
//
namespace LoadBalancing
{

//
// IDL:ooc.com/LoadBalancing/GroupORT:1.0
//
class GroupORT_impl : virtual public OBV_LoadBalancing::GroupORT,
                      virtual public CORBA::DefaultValueRefCountBase
{
    GroupORT_impl(const GroupORT_impl&);
    void operator=(const GroupORT_impl&);

public:

    GroupORT_impl();
    GroupORT_impl(const char*, PortableInterceptor::ObjectReferenceTemplate*);
    ~GroupORT_impl();

    virtual CORBA::ValueBase* _copy_value();

    //
    // IDL:omg.org/PortableInterceptor/ObjectReferenceTemplate/server_id:1.0
    //
    virtual PortableInterceptor::ServerId server_id();

    //
    // IDL:omg.org/PortableInterceptor/ObjectReferenceTemplate/orb_id:1.0
    //
    virtual PortableInterceptor::ORBId orb_id();

    //
    // IDL:omg.org/PortableInterceptor/ObjectReferenceTemplate/adapter_name:1.0
    //
    virtual PortableInterceptor::AdapterName* adapter_name();

    //
    // IDL:omg.org/PortableInterceptor/ObjectReferenceTemplate/make_object:1.0
    //
    virtual CORBA::Object_ptr make_object(
	const char* repository_id,
	const PortableInterceptor::ObjectId& id);
};

class GroupORTFactory_impl : virtual public CORBA::ValueFactoryBase
{
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    GroupORTFactory_impl();
    virtual ~GroupORTFactory_impl();
};

} // End of namespace LoadBalancing

#endif
