// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef __OB_StrategyBase_h__
#define __OB_StrategyBase_h__

#include <OB/Balancer_skel.h>

#include <BalancerDatabase_fwd.h>

//
// IDL:ooc.com/LoadBalancing:1.0
//
namespace LoadBalancing
{

//
// The base class for strategies.
//
class StrategyBase : virtual public POA_LoadBalancing::Strategy,
		     virtual public PortableServer::RefCountServantBase
{
protected:

    //
    // The POA
    //
    PortableServer::POA_var poa_;

    //
    // The database
    //
    Database_var db_;

    StrategyBase(PortableServer::POA_ptr, Database_ptr);
    ~StrategyBase();

public:

    virtual PortableServer::POA_ptr _default_POA();

    //
    // IDL:ooc.com/LoadBalancing/Strategy/get_properties:1.0
    //
    virtual LoadBalancing::PropertySeq* get_properties()
        throw(CORBA::SystemException);

    //
    // IDL:ooc.com/LoadBalancing/Strategy/push_load:1.0
    //
    virtual void push_load(const char* member_id,
			   CORBA::ULong load)
        throw(LoadBalancing::MemberNotFound,
	      LoadBalancing::StrategyNotAdaptive,
	      CORBA::SystemException);

    //
    // IDL:ooc.com/LoadBalancing/Strategy/destroy:1.0
    //
    virtual void destroy()
        throw(CORBA::SystemException);
};

} // End of namespace LoadBalancing

#endif
