# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

UTILLIB_NAME	= $(top_srcdir)\lib\BalancerUtil$(LIBSUFFIX).lib

UTILLIB_PDB_NAME= $(top_srcdir)\lib\BalancerUtil$(LIBSUFFIX).pdb

ADMIN_NAME	= $(top_srcdir)\bin\lbadmin.exe
MKREF_NAME	= $(top_srcdir)\bin\lbmkref.exe

UTILS		= $(ADMIN_NAME) \
		  $(MKREF_NAME)

#
# Work around the inference rules problem with nmake.
#
!if !defined(BUILD_STAGE)

PDB_FLAGS   	= /Fd$(UTILLIB_PDB_NAME)
TARGETS		= $(UTILLIB_NAME)

!elseif $(BUILD_STAGE) == 1

TARGETS 	= $(UTILS)
PDB_FILES       = $(UTILS:.exe=.pdb) \
		  $(UTILLIB_PDB_NAME)

!endif

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl\OB
HDIR		= $(top_srcdir)\include\OB

UTILLIB_OBJS	= BalancerUtil.obj \
		  UtilInitializer.obj \
		  UtilLogger.obj \
		  LoadAlertInterceptor.obj \
		  LoadCalculator_impl.obj \
		  LoadAlert_impl.obj \
		  LoadUpdater_impl.obj

ADMIN_OBJS	= LBAdmin.obj

MKREF_OBJS	= LBMkref.obj

#
# When not in DLL mode these symbols are also needed for clean target
#
UTILLIB_DEF_NAME= BalancerUtil$(LIBSUFFIX).def
UTILLIB_DLL_NAME= $(top_srcdir)\lib\BalancerUtil$(OB_LIBVER)$(LIBSUFFIX).dll
UTILLIB_EXP_NAME= $(top_srcdir)\lib\BalancerUtil$(LIBSUFFIX).exp

ALL_CPPFLAGS    = /I$(top_srcdir)\include /I. $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_IDLFLAGS    = -I$(top_srcdir)/idl -I. $(OB_IDLFLAGS)

!if !defined(BUILD_STAGE)

ALL_CPPFLAGS = /DOB_BALANCER_UTIL_IMPORT=/**/ $(ALL_CPPFLAGS)

!endif

!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS) 

ALL_DLLLIBS	= $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(UTILLIB_NAME): $(UTILLIB_DLL_NAME)

$(UTILLIB_DEF_NAME):

$(UTILLIB_DLL_NAME): $(UTILLIB_OBJS) \
		     $(top_srcdir)\lib\Balancer$(LIBSUFFIX).lib \
		     $(UTILLIB_DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(UTILLIB_DEF_NAME) \
	BalancerUtil$(OB_LIBVER)$(LIBSUFFIX) $(UTILLIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x55B00000 /def:$(UTILLIB_DEF_NAME) \
	/IMPLIB:$(UTILLIB_NAME) /out:$@ $(UTILLIB_OBJS) \
	$(top_srcdir)\lib\Balancer$(LIBSUFFIX).lib $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)

$(UTILLIB_NAME): $(UTILLIB_OBJS) $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(UTILLIB_OBJS) $(LIB_OBJS)

!endif

ALL_LIBS = $(OB_LIBS) $(LIBS)

$(ADMIN_NAME): $(ADMIN_OBJS) $(UTILLIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(ADMIN_OBJS) \
	$(top_srcdir)\lib\Balancer$(LIBSUFFIX).lib $(ALL_LIBS)

$(MKREF_NAME): $(MKREF_OBJS) $(UTILLIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(MKREF_OBJS) $(ALL_LIBS)

BalancerUtil.cpp $(HDIR)/BalancerUtil.h: $(IDLDIR)/BalancerUtil.idl
	-del BalancerUtil.cpp
	-del $(HDIR)\BalancerUtil.h
	$(IDL) $(ALL_IDLFLAGS) --no-type-codes --no-skeletons \
	    --this-header-dir OB \
	    --dll-import OB_BALANCER_UTIL_IMPORT $(IDLDIR)/BalancerUtil.idl
	move BalancerUtil.h $(HDIR)

#
# Work around the inference rules problem with nmake.
#
!ifndef BUILD_STAGE

install:: all

all depend install clean test::
    $(MAKE) /f Makefile.mak BUILD_STAGE=1 $@

!elseif $(BUILD_STAGE) == 1

install:: all
	copy $(UTILLIB_NAME) $(libdir)
	if exist $(UTILLIB_PDB_NAME) \
	    copy $(UTILLIB_PDB_NAME) $(libdir)
	copy $(ADMIN_NAME) $(bindir)
	copy $(MKREF_NAME) $(bindir)

!if "$(DLL)" == "yes"

UTILLIB_DLL_PDB = $(UTILLIB_DLL_NAME:.dll=.pdb)

install:: all
	copy $(UTILLIB_DLL_NAME) $(libdir)
	copy $(UTILLIB_EXP_NAME) $(libdir)
	if exist $(UTILLIB_DLL_PDB) copy $(UTILLIB_DLL_PDB) $(libdir)

!endif

clean::
	-del $(UTILLIB_DLL_NAME) $(UTILLIB_EXP_NAME) $(UTILLIB_DEF_NAME) \
	$(UTILLIB_DLL_NAME:.dll=.pdb)

clean::
	-del $(ADMIN_NAME) $(ADMIN_NAME:.exe=.pdb)
	-del $(MKREF_NAME) $(MKREF_NAME:.exe=.pdb)

!endif

min:: all

install_min:: install

!include .windep
