// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef ___LoadAlert_impl_h__
#define ___LoadAlert_impl_h__

#include <OB/Balancer_skel.h>

//
// LoadAlert servant class.
//
class LoadAlert_impl : public POA_LoadBalancing::LoadAlert,
		       public PortableServer::RefCountServantBase,
		       public JTCMutex
{
    PortableServer::POA_var poa_;
    int count_;

public:
    LoadAlert_impl(PortableServer::POA_ptr poa)
	: poa_(PortableServer::POA::_duplicate(poa)),
	  count_(0)
    {
    }

    virtual PortableServer::POA_ptr _default_POA()
    {
	return PortableServer::POA::_duplicate(poa_);
    }

    virtual void alert()
	throw(CORBA::SystemException)
    {
	JTCSynchronized sync(*this);
	count_++;
    }

    int getCount()
    {
	JTCSynchronized sync(*this);
	return count_;
    }

    void resetCount()
    {
	JTCSynchronized sync(*this);
	count_ = 0;
    }
};

#endif
