// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <Hello_impl.h>

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

Hello_impl::Hello_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr poa)
    : orb_(CORBA::ORB::_duplicate(orb)),
      poa_(PortableServer::POA::_duplicate(poa))
{
}

PortableServer::POA_ptr
Hello_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(poa_);
}

void
Hello_impl::say_hello(HelloCallback_ptr cb)
    throw(CORBA::SystemException)
{
    cout << "Hello World!" << endl;
    try
    {
        cb -> hello_callback();
    }
    catch(const CORBA::SystemException& ex)
    {
        cerr << "Hello_impl: Callback failed!" << endl;
        cerr << ex << endl;
    }
}

void
Hello_impl::deactivate()
    throw(CORBA::SystemException)
{
    orb_ -> shutdown(false);
}
