# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

LIB_NAME	= $(top_srcdir)\lib\OCI_bidir$(LIBSUFFIX).lib
LIB_PDB_NAME    = $(top_srcdir)\lib\OCI_bidir$(LIBSUFFIX).pdb

PDB_FILES       = $(LIB_PDB_NAME)

PDB_FLAGS       = /Fd$(LIB_PDB_NAME)
TARGETS		= $(LIB_NAME)

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl\OB
HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= BiDirIOP.obj \
		  OCI_BiDir.obj \
		  OCI_BiDir_impl.obj \
		  OCI_BiDir_init.obj \
		  ActiveTransport.obj \
		  TransportManager.obj

DEF_NAME = OCI_bidir$(LIBSUFFIX).def
DLL_NAME = $(top_srcdir)\lib\OCI_bidir$(OB_LIBVER)$(LIBSUFFIX).dll
EXP_NAME = $(top_srcdir)\lib\OCI_bidir$(LIBSUFFIX).exp

!ifndef BUILD_UTILS
ALL_CPPFLAGS    = /DOB_BIDIR_IMPORT=/**/ /I. /I$(top_srcdir)\include \
                  $(OB_CPPFLAGS) $(CPPFLAGS)
!else
ALL_CPPFLAGS    = /I. /I$(top_srcdir)\include $(OB_CPPFLAGS) $(CPPFLAGS)
!endif

ALL_CXXFLAGS    = $(CXXFLAGS)
ALL_LIBS        = $(LIB_NAME) $(OB_LIBS) $(LIBS)
ALL_IDLFLAGS	= --this-header-dir OB --dll-import OB_BIDIR_IMPORT \
		  $(OB_IDLFLAGS)

!if "$(DLL)" == "yes"

ALL_DLLLIBS     = $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(LIB_NAME): $(DLL_NAME)

$(DEF_NAME):

$(DLL_NAME): $(LIB_OBJS) $(DEF_NAME)
        perl $(top_srcdir)\..\config\makedef.pl $(DEF_NAME) \
        OCI_bidir$(OB_LIBVER)$(LIBSUFFIX) $(LIB_OBJS)
        $(LINK) $(LINKDLLFLAGS) /BASE:0x54C00000 /def:$(DEF_NAME) \
        /IMPLIB:$(LIB_NAME) /out:$@ $(LIB_OBJS) $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS    = $(CXXFLAGS) $(PDB_FLAGS)

$(LIB_NAME): $(LIB_OBJS)
        -del $@
        $(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

!endif

BiDirIOP.cpp $(HDIR)\BiDirIOP.h: $(IDLDIR)\BiDirIOP.idl
	-del BiDirIOP.cpp
	-del $(HDIR)\BiDirIOP.h
	$(IDL) $(ALL_IDLFLAGS) --no-skeletons $(IDLDIR)\BiDirIOP.idl
	move BiDirIOP.h $(HDIR)

OCI_BiDir.cpp $(HDIR)\OCI_BiDir.h: $(IDLDIR)\OCI_BiDir.idl
	-del OCI_BiDir.cpp
	-del $(HDIR)\OCI_BiDir.h
	$(IDL) $(ALL_IDLFLAGS) --no-skeletons $(IDLDIR)\OCI_BiDir.idl
	move OCI_BiDir.h $(HDIR)

install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(LIB_PDB_NAME) copy $(LIB_PDB_NAME) $(libdir)

!if "$(DLL)" == "yes"

DLL_PDB = $(DLL_NAME:.dll=.pdb)

install:: all
	copy $(DLL_NAME) $(libdir)
	copy $(EXP_NAME) $(libdir)
	if exist $(DLL_PDB) copy $(DLL_PDB) $(libdir)

!endif

clean::
        -del $(DLL_NAME) $(EXP_NAME) $(DEF_NAME) $(DLL_NAME:.dll=.pdb)

min:: all

install_min:: install

!include .windep
