dnl **********************************************************************
dnl
dnl Copyright (c) 2002
dnl IONA Technologies, Inc.
dnl Waltham, MA, USA
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl ORBacus/E-specific configuration
dnl ----------------------------------------------------------------------

AC_SUBST(OBE_CPPFLAGS)
AC_SUBST(OBE_LDFLAGS)
AC_SUBST(OBE_IDLFLAGS)
AC_SUBST(OBE_CLIENT_LIBS)
AC_SUBST(OBE_SERVER_LIBS)
AC_SUBST(OBE_LIBVER)
AC_SUBST(EIDL)

OBE_CPPFLAGS=
OBE_LDFLAGS=
OBE_IDLFLAGS=
OBE_CLIENT_LIBS=
OBE_SERVER_LIBS=
OBE_LIBVER=
EIDL=eidl

dnl
dnl Discover the ORBacus/E path.
dnl
obe_path=

if test -z "$obe_path" -a -n "$with_obe" -a "$with_obe" != "yes"
then
    if test "$with_obe" = "no"
    then
	AC_MSG_ERROR(ORBacus/E required!)
    fi

    dnl
    dnl Search in the directory specified by the --with-ob option
    dnl
    obe_path="${with_obe}/"
    if test ! -f ${obe_path}include/OBE/CORBA.h
    then
	obe_path="${obe_path}obe/"
	if test ! -f ${obe_path}include/OBE/CORBA.h
	then
	    obe_path=
	fi
    fi
fi

if test -z "$obe_path"
then
    dnl
    dnl Search in the current directory or ../ob
    dnl	
    obe_path="./"
    if test ! -f ${obe_path}include/OBE/CORBA.h
    then
	obe_path="../obe/"
	if test ! -f ${obe_path}include/OBE/CORBA.h
	then
	    obe_path=
	fi
    fi
fi

if test -z "$obe_path" -a -n "$prefix"
then
    dnl
    dnl Search in the installation directory
    dnl
    obe_path="${prefix}/"
    if test ! -f ${obe_path}include/OBE/CORBA.h
    then
	obe_path="${obe_path}obe/"
	if test ! -f ${obe_path}include/OBE/CORBA.h
	then
	    obe_path=
	fi
    fi	
fi

dnl
dnl Error message if we didn't find the ORBacus path.
dnl
if test ! -f ${obe_path}include/OBE/CORBA.h
then
    AC_MSG_ERROR(Can't find ORBacus/E! Use the --with-obe=DIR option.)
fi

dnl
dnl ORBacus/E shared library versioning
dnl
obe_ver=""
if test "$LIBEXT" != ".a"
then
    obe_ver=`grep '#define OBE_VERSION' \
 	< ${obe_path}include/OBE/Basic.h | sed -e 's/^.* \"//' -e 's/\"$//'`
    OBE_LIBVER=".${obe_ver}"
fi

dnl
dnl Add $(top_srcdir) to relative paths (current directory and ../ob)
dnl
if test "$obe_path" = "./"
then
    obe_path="\$(top_srcdir)/"
fi

if test "$obe_path" = "../obe/"
then
    obe_path="\$(top_srcdir)/../obe/"
fi

OBE_LDFLAGS="$OBE_LDFLAGS -L${obe_path}lib"
OBE_CPPFLAGS="$OBE_CPPFLAGS -I${obe_path}include"
OBE_IDLFLAGS="$OBE_IDLFLAGS -I${obe_path}idl"
OBE_CLIENT_LIBS="$OBE_CLIENT_LIBS -lOBEClient"
OBE_SERVER_LIBS="$OBE_SERVER_LIBS -lOBEServer"
if test -f ../ob/include/OB/CORBA.h
then
    if test "$cross_compiling" = "yes"
    then
        EIDL="eidl-native"
    else
        EIDL="${obe_path}../ob/bin/eidl"
    fi 
fi

#
# Check that the JThreads/C++ package is installed and set the 
# appropriate compiler flags and variables.
#
builtin(include,../config/jtc.m4)

dnl
dnl Add JTC path and library to the OB variables.
dnl
if test "$jtc_path" != "$obe_path"
then
    OBE_LDFLAGS="$OBE_LDFLAGS $JTC_LDFLAGS"
    OBE_CPPFLAGS="$OBE_CPPFLAGS $JTC_CPPFLAGS"
fi

OBE_CLIENT_LIBS="$OBE_CLIENT_LIBS $JTC_LIBS"
OBE_SERVER_LIBS="$OBE_SERVER_LIBS $JTC_LIBS"
