dnl **********************************************************************
dnl
dnl Copyright (c) 2002
dnl IONA Technologies, Inc.
dnl Waltham, MA, USA
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl ORBacus-specific configuration
dnl ----------------------------------------------------------------------

AC_SUBST(OBUTIL_CPPFLAGS)
AC_SUBST(OBUTIL_LDFLAGS)
AC_SUBST(OBUTIL_LIBS)

OBUTIL_CPPFLAGS=
OBUTIL_LDFLAGS=
OBUTIL_LIBS=

dnl
dnl The util default directory
dnl 
obutil_path="../util/"

dnl
dnl If the --with-obutil option contains a directory then check that this 
dnl directory contains the util sources.
dnl
if test -n "$with_obutil" -a "$with_obutil" != "no" -a "$with_obutil" != "yes"
then
    obutil_path="${with_obutil}/"
    if test ! -f ${obutil_path}src/database/Database.cpp
    then
	obutil_path="${obutil_path}util/"
    fi	
fi

dnl
dnl If we didn't find the util directory print an error message
dnl 
if test ! -f ${obutil_path}src/database/Database.cpp
then
    AC_MSG_ERROR(Can't find ORBacus util directory! Use the --with-obutil=path option.)
fi

if test ! \( -n "$with_obutil" -a "$with_obutil" != "no" -a "$with_obutil" != "yes" \)
then
    obutil_path="\$(top_srcdir)/$obutil_path"
fi

OBUTIL_LDFLAGS="$OBUTIL_LDFLAGS -L${obutil_path}lib"
OBUTIL_CPPFLAGS="$OBUTIL_CPPFLAGS -I${obutil_path}include"
OBUTIL_LIBS="$OBUTIL_LIBS -lOBDB -lOBExtendedTcl"

