dnl ----------------------------------------------------------------------
dnl ORACLE specific configuration
dnl The "--with-oracle" option must be used to enable ORACLE support
dnl ----------------------------------------------------------------------

AC_SUBST(WITH_ORACLE)
AC_SUBST(ORACLE_CPPFLAGS)
AC_SUBST(ORACLE_LDFLAGS)
AC_SUBST(ORACLE_LIBS)
WITH_ORACLE=no
ORACLE_CPPFLAGS=
ORACLE_LDFLAGS=
ORACLE_LIBS=

AC_ARG_WITH(oracle,
  --with-oracle=path     make use of Oracle,
if test "$with_oracle" != "no"
then
    AC_MSG_CHECKING(Oracle)
    if test -z "$with_oracle" -o "$with_oracle" = "yes"
    then
        AC_MSG_RESULT(no)
        AC_MSG_ERROR(Can't find Oracle! Use the --with-oracle=path option.)
    fi
    ORACLE_CPPFLAGS=-I${with_oracle}/precomp/public
    ORACLE_LDFLAGS=-L${with_oracle}/lib
    ORACLE_LIBS="-lclntsh -lwtc8"
    AC_MSG_RESULT(${with_oracle})
    WITH_ORACLE=yes
fi
)

