// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef CHANNEL_TYPE_H
#define CHANNEL_TYPE_H

typedef OB_STL::list<CORBA::String_var> StringList;

class ChannelType
{
    //
    // The ORB
    //
    CORBA::ORB_var orb_;

    //
    // Repository IDs for the channel
    //
    StringList typeIds_;

    //
    // The operations supported by the channel's interface. 
    //
    CORBA::OpDescriptionSeq operations_;

    //
    // Get assigned type-ids for this channel.
    //
    void typeIds(CORBA::InterfaceDef_ptr);

    //
    // The channel's interface repository id.
    //
    CORBA::String_var interfaceId_;

public:

    ChannelType(CORBA::ORB_ptr);

    //
    // Verify if the channel has a compatible typeId assigned.
    //
    bool isCompatible(const char*);

    //
    // Assign the type-id to the channel, if not already assigned.
    //
    bool assignTypeId(const char*);

    //
    // Get the operations available on the channel type. 
    //
    CORBA::OpDescriptionSeq* getOperations();

    //
    // Get the interface ID for the channel type.
    //
    CORBA::RepositoryId getInterfaceId();
};

#endif // CHANNEL_TYPE_H
