// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_CONSUMER_ADMIN_IMPL_H
#define COS_CONSUMER_ADMIN_IMPL_H

//
// Forward declarations.
//
class Reaper;

//
// The event channel ConsumerAdmin class
// 
class EC_ConsumerAdmin_impl : public POA_CosEventChannelAdmin::ConsumerAdmin,
			      public AdminBase
{
    //
    // No copy constructor/assignment operator
    //
    EC_ConsumerAdmin_impl(const EC_ConsumerAdmin_impl&);
    void operator=(const EC_ConsumerAdmin_impl&);

    virtual void deactivateObject();

public:

    EC_ConsumerAdmin_impl(CORBA::ORB_ptr, PortableServer::POA_ptr,
    			  OB::EventLogger_ptr, Reaper*, PipeSegment_ptr);
    ~EC_ConsumerAdmin_impl();

    //
    // Standard IDL to C++ Mapping
    //

    //
    // Get ProxyPushSupplier.
    //
    virtual CosEventChannelAdmin::ProxyPushSupplier_ptr obtain_push_supplier()
	throw(CORBA::SystemException);

    //
    // Get ProxyPullSupplier.
    //
    virtual CosEventChannelAdmin::ProxyPullSupplier_ptr obtain_pull_supplier()
	throw(CORBA::SystemException);
};

#endif
