// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_PROXY_PULL_CONSUMER_IMPL_H
#define COS_PROXY_PULL_CONSUMER_IMPL_H

//
// Forward declarations
//
class PropagatorBaseThread;
typedef JTCHandleT<PropagatorBaseThread> PropagatorBaseThreadHandle;

class EC_ProxyPullConsumer_impl :
    public POA_CosEventChannelAdmin::ProxyPullConsumer,
    public ProxyBase
{
    //
    // No copy constructor/assignment operator.
    //
    EC_ProxyPullConsumer_impl(const EC_ProxyPullConsumer_impl&);
    void operator=(const EC_ProxyPullConsumer_impl&);

    PropagatorBaseThreadHandle puller_; // The event puller

    CosEventComm::PullSupplier_var supplier_; // My pull supplier
    
public:

    EC_ProxyPullConsumer_impl(ProxyConstructorInfo&);
    ~EC_ProxyPullConsumer_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual void connect_pull_supplier(CosEventComm::PullSupplier_ptr)
	throw(CosEventChannelAdmin::AlreadyConnected,
	      CosEventChannelAdmin::TypeError,
	      CORBA::SystemException);

    virtual void disconnect_pull_consumer()
	throw(CORBA::SystemException);

    //
    // Internal methods
    //

    //
    // Disconnect the servant from the ORB
    //
    virtual void deactivateObject();

    //
    // Called during disconnect
    //
    virtual void disconnectPeer();

    //
    // Provides the implementation of discardRequests() without
    // synchronization
    //
    virtual void discardRequestsImpl();

    //
    // Can this proxy be reaped?
    //
    virtual bool canReap();
};

#endif
