// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_PROXY_PUSH_SUPPLIER_IMPL_H
#define COS_PROXY_PUSH_SUPPLIER_IMPL_H

//
// The Event Channel ProxyPushConsumer implementation
//
class EC_ProxyPushConsumer_impl :
    public POA_CosEventChannelAdmin::ProxyPushConsumer,
    public ProxyBase
{
    //
    // No copy constructor/assignment operator
    //
    EC_ProxyPushConsumer_impl(const EC_ProxyPushConsumer_impl&);
    void operator=(const EC_ProxyPushConsumer_impl&);
    
    CosEventComm::PushSupplier_var supplier_; // My push supplier

public:
    
    EC_ProxyPushConsumer_impl(ProxyConstructorInfo&);
    ~EC_ProxyPushConsumer_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual void connect_push_supplier(CosEventComm::PushSupplier_ptr)
	throw(CosEventChannelAdmin::AlreadyConnected,
	      CORBA::SystemException);

    virtual void disconnect_push_consumer()
        throw(CORBA::SystemException);

    virtual void push(const CORBA::Any&)
        throw(CosEventComm::Disconnected, CORBA::SystemException);

    //
    // Internal methods
    //

    //
    // Disconnect the servant from the ORB
    //
    virtual void deactivateObject();

    //
    // Called during disconnect
    //
    virtual void disconnectPeer();

    //
    // Can this proxy be reaped?
    //
    virtual bool canReap();
};

#endif
