# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

#
# Three libraries are created. CosEvent is for end-users, OBEvent and
# OBEventService are for the applications that need to actually include
# an implementation of the service.
#
LIB_NAME	= $(top_srcdir)\lib\CosEvent$(LIBSUFFIX).lib
SKELLIB_NAME	= $(top_srcdir)\lib\OBEvent$(LIBSUFFIX).lib
SERVLIB_NAME	= $(top_srcdir)\lib\OBEventService$(LIBSUFFIX).lib

LIB_PDB_NAME	= $(top_srcdir)\lib\CosEvent$(LIBSUFFIX).pdb
SKELLIB_PDB_NAME= $(top_srcdir)\lib\OBEvent$(LIBSUFFIX).pdb
SERVLIB_PDB_NAME= $(top_srcdir)\lib\OBEventService$(LIBSUFFIX).pdb

ADMIN_NAME	= $(top_srcdir)\bin\eventadmin.exe
SERVER_NAME	= $(top_srcdir)\bin\eventserv.exe
SERVICE_NAME    = $(top_srcdir)\bin\nteventservice.exe

UTILS           = $(ADMIN_NAME) \
		  $(SERVER_NAME) \
		  $(SERVICE_NAME)

#
# Work around the inference rules problem with nmake.
#
!if !defined(BUILD_STAGE)

PDB_FLAGS       = /Fd$(LIB_PDB_NAME)

TARGETS		= $(LIB_NAME)

!elseif $(BUILD_STAGE) == 1

PDB_FLAGS   	= /Fd$(SKELLIB_PDB_NAME)
TARGETS		= $(SKELLIB_NAME)

!elseif $(BUILD_STAGE) == 2

PDB_FLAGS   	= /Fd$(SERVLIB_PDB_NAME)
TARGETS		= $(SERVLIB_NAME)

!elseif $(BUILD_STAGE) == 3

TARGETS		= $(UTILS)
PDB_FILES       = $(UTILS:.exe=.pdb) \
		  $(LIB_PDB_NAME) \
		  $(SKELLIB_PDB_NAME) \
		  $(SERVLIB_PDB_NAME)

!endif

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl\OB
HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= CosEventComm.obj \
		  CosEventComm_skel.obj \
		  CosEventChannelAdmin.obj \
		  CosTypedEventComm.obj \
		  CosTypedEventComm_skel.obj \
		  CosTypedEventChannelAdmin.obj \
		  OBEventChannelFactory.obj \
		  OBTypedEventChannelFactory.obj \
		  OBEventReceiver.obj

#
# SKELLIB includes LIB_OBJS plus the missing _skel files
#
SKELLIB_OBJS   = OBEventReceiver_skel.obj \
		 CosEventChannelAdmin_skel.obj \
		 CosTypedEventChannelAdmin_skel.obj \
		 OBEventChannelFactory_skel.obj \
		 OBTypedEventChannelFactory_skel.obj

SERVLIB_OBJS	= EC_EventChannel_impl.obj \
		  EC_ConsumerAdmin_impl.obj \
		  EC_SupplierAdmin_impl.obj \
		  EC_ProxyPushConsumer_impl.obj \
		  EC_ProxyPushSupplier_impl.obj \
		  EC_ProxyPullSupplier_impl.obj \
		  EC_ProxyPullConsumer_impl.obj \
		  ChannelType.obj \
		  TEC_TypedEventChannel_impl.obj \
		  TEC_TypedConsumerAdmin_impl.obj \
		  TEC_TypedSupplierAdmin_impl.obj \
		  TEC_TypedProxyPushConsumer_impl.obj \
		  TEC_ProxyPushSupplier_impl.obj \
		  EventLogger.obj \
		  Event_impl.obj \
		  PropagatorBaseThread.obj \
		  PusherBaseThread.obj \
		  ProxyBase.obj \
		  EventUtil.obj \
		  SetDefaultProperties.obj \
		  EventChannelFactory_impl.obj \
		  TypedEventChannelFactory_impl.obj \
		  QoS.obj \
		  PipeSegment.obj \
		  Reaper.obj \
		  AdminBase.obj \
		  EventService.obj \
		  TypedEventService.obj

SERVICE_OBJS	= NTEventService.obj \
		  NTServiceMain.obj \
		  EventMsg.res

SERVER_OBJS	= Server.obj

ADMIN_OBJS	= EventAdmin.obj

#
# When not in DLL mode these symbols are also needed for clean target
#
LIB_DEF_NAME	= CosEvent$(LIBSUFFIX).def
LIB_DLL_NAME    = $(top_srcdir)\lib\CosEvent$(OB_LIBVER)$(LIBSUFFIX).dll
LIB_EXP_NAME    = $(top_srcdir)\lib\CosEvent$(LIBSUFFIX).exp

SKELLIB_DEF_NAME= OBEvent$(LIBSUFFIX).def
SKELLIB_DLL_NAME= $(top_srcdir)\lib\OBEvent$(OB_LIBVER)$(LIBSUFFIX).dll
SKELLIB_EXP_NAME= $(top_srcdir)\lib\OBEvent$(LIBSUFFIX).exp

SERVLIB_DEF_NAME= OBEventService$(LIBSUFFIX).def
SERVLIB_DLL_NAME= $(top_srcdir)\lib\OBEventService$(OB_LIBVER)$(LIBSUFFIX).dll
SERVLIB_EXP_NAME= $(top_srcdir)\lib\OBEventService$(LIBSUFFIX).exp


ALL_CPPFLAGS	= /I. /I$(top_srcdir)\include $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_IDLFLAGS	= -I$(top_srcdir)\idl

DLL_CPPFLAGS = /DOB_EVENT_IMPORT=/**/

!if !defined(BUILD_STAGE)

ALL_CPPFLAGS = $(DLL_CPPFLAGS) $(ALL_CPPFLAGS)

!elseif $(BUILD_STAGE) == 1

ALL_CPPFLAGS = $(DLL_CPPFLAGS) $(ALL_CPPFLAGS)

!endif

!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS) 

ALL_DLLLIBS	= $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(LIB_NAME): $(LIB_DLL_NAME)

$(SKELLIB_NAME): $(SKELLIB_DLL_NAME)

$(SERVLIB_NAME): $(SERVLIB_DLL_NAME)

$(LIB_DEF_NAME):

$(SKELLIB_DEF_NAME):

$(SERVLIB_DEF_NAME):

$(LIB_DLL_NAME): $(LIB_OBJS) $(LIB_DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(LIB_DEF_NAME) \
	CosEvent$(OB_LIBVER)$(LIBSUFFIX) $(LIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x56000000 /def:$(LIB_DEF_NAME) \
	/IMPLIB:$(LIB_NAME) /out:$@ $(LIB_OBJS) $(ALL_DLLLIBS)

$(SKELLIB_DLL_NAME): $(SKELLIB_OBJS) $(LIB_OBJS) $(SKELLIB_DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(SKELLIB_DEF_NAME) \
	OBEvent$(OB_LIBVER)$(LIBSUFFIX) $(SKELLIB_OBJS) $(LIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x56A00000 /def:$(SKELLIB_DEF_NAME) \
	/IMPLIB:$(SKELLIB_NAME) /out:$@ $(SKELLIB_OBJS) $(LIB_OBJS) \
	$(ALL_DLLLIBS)

$(SERVLIB_DLL_NAME): $(SERVLIB_OBJS) $(SERVLIB_DEF_NAME) $(SKELLIB_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(SERVLIB_DEF_NAME) \
	OBEventService$(OB_LIBVER)$(LIBSUFFIX) $(SERVLIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x56B00000 /def:$(SERVLIB_DEF_NAME) \
	/IMPLIB:$(SERVLIB_NAME) /out:$@ $(SERVLIB_OBJS) $(ALL_DLLLIBS) \
	$(SKELLIB_NAME)

!else

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)

$(LIB_NAME): $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SKELLIB_NAME): $(SKELLIB_OBJS) $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(SKELLIB_OBJS) $(LIB_OBJS)

$(SERVLIB_NAME): $(SERVLIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(SERVLIB_OBJS)

!endif

ALL_LIBS = $(SERVLIB_NAME) $(SKELLIB_NAME) $(OB_LIBS) $(LIBS)

$(SERVER_NAME): $(SERVER_OBJS) $(SKELLIB_NAME) $(SERVLIB_NAME)
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ \
	$(SERVER_OBJS) $(ALL_LIBS)

$(SERVICE_NAME): $(SERVICE_OBJS) $(SKELLIB_NAME) $(SERVLIB_NAME)
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ $(SERVICE_OBJS) $(ALL_LIBS)

$(ADMIN_NAME): $(ADMIN_OBJS) $(LIB_NAME)
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ \
	$(ADMIN_OBJS) $(LIB_NAME) $(OB_LIBS) $(LIBS)

CosEventChannelAdmin.cpp $(HDIR)\CosEventChannelAdmin.h: \
					$(IDLDIR)\CosEventChannelAdmin.idl
	-del CosEventChannelAdmin.cpp
	-del $(HDIR)\CosEventChannelAdmin.h
	-del CosEventChannelAdmin_skel.cpp
	-del $(HDIR)\CosEventChannelAdmin_skel.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB --dll-import \
	OB_EVENT_IMPORT $(IDLDIR)\CosEventChannelAdmin.idl
	move CosEventChannelAdmin.h $(HDIR)
	move CosEventChannelAdmin_skel.h $(HDIR)

CosEventChannelAdmin_skel.cpp $(HDIR)\CosEventChannelAdmin_skel.h: \
					CosEventChannelAdmin.cpp

CosEventComm.cpp $(HDIR)\CosEventComm.h: $(IDLDIR)\CosEventComm.idl
	-del CosEventComm.cpp $(HDIR)\CosEventComm.h
	-del CosEventComm_skel.cpp $(HDIR)\CosEventComm_skel.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB --dll-import \
	OB_EVENT_IMPORT $(IDLDIR)\CosEventComm.idl
	move CosEventComm.h $(HDIR)
	move CosEventComm_skel.h $(HDIR)

CosEventComm_skel.cpp $(HDIR)\CosEventComm_skel.h: CosEventComm.cpp

CosTypedEventChannelAdmin.cpp $(HDIR)\CosTypedEventChannelAdmin.h: \
					$(IDLDIR)\CosTypedEventChannelAdmin.idl
	-del CosTypedEventChannelAdmin.cpp
	-del $(HDIR)\CosTypedEventChannelAdmin.h
	-del CosTypedEventChannelAdmin_skel.cpp
	-del $(HDIR)\CosTypedEventChannelAdmin_skel.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB --dll-import \
	OB_EVENT_IMPORT $(IDLDIR)\CosTypedEventChannelAdmin.idl
	move CosTypedEventChannelAdmin.h $(HDIR)
	move CosTypedEventChannelAdmin_skel.h $(HDIR)

CosTypedEventChannelAdmin_skel.cpp $(HDIR)\CosTypedEventChannelAdmin_skel.h: \
					CosTypedEventChannelAdmin.cpp

CosTypedEventComm.cpp $(HDIR)\CosTypedEventComm.h: \
					$(IDLDIR)\CosTypedEventComm.idl
	-del CosTypedEventComm.cpp $(HDIR)\CosTypedEventComm.h
	-del CosTypedEventComm_skel.cpp $(HDIR)\CosTypedEventComm_skel.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB --dll-import \
	OB_EVENT_IMPORT $(IDLDIR)\CosTypedEventComm.idl
	move CosTypedEventComm.h $(HDIR)
	move CosTypedEventComm_skel.h $(HDIR)

CosTypedEventComm_skel.cpp $(HDIR)\CosTypedEventComm_skel.h: \
					CosTypedEventComm.cpp

OBEventChannelFactory.cpp $(HDIR)\OBEventChannelFactory.h: \
					$(IDLDIR)\OBEventChannelFactory.idl
	-del OBEventChannelFactory.cpp $(HDIR)\OBEventChannelFactory.h
	-del OBEventChannelFactory_skel.cpp \
	$(HDIR)\OBEventChannelFactory_skel.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB --dll-import \
	OB_EVENT_IMPORT $(IDLDIR)\OBEventChannelFactory.idl
	move OBEventChannelFactory.h $(HDIR)
	move OBEventChannelFactory_skel.h $(HDIR)

OBEventChannelFactory_skel.cpp $(HDIR)\OBEventChannelFactory_skel.h: \
					OBEventChannelFactory.cpp

OBTypedEventChannelFactory.cpp $(HDIR)\OBTypedEventChannelFactory.h: \
				$(IDLDIR)\OBTypedEventChannelFactory.idl
	-del OBTypedEventChannelFactory.cpp \
	$(HDIR)\OBTypedEventChannelFactory.h
	-del OBTypedEventChannelFactory_skel.cpp \
	$(HDIR)\OBTypedEventChannelFactory_skel.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB --dll-import \
	OB_EVENT_IMPORT $(IDLDIR)\OBTypedEventChannelFactory.idl
	move OBTypedEventChannelFactory.h $(HDIR)
	move OBTypedEventChannelFactory_skel.h $(HDIR)

OBTypedEventChannelFactory_skel.cpp $(HDIR)\OBTypedEventChannelFactory_skel.h:\
				OBTypedEventChannelFactory.cpp

OBEventReceiver.cpp $(HDIR)\OBEventReceiver.h:  $(IDLDIR)\OBEventReceiver.idl
	-del OBEventReceiver.cpp $(HDIR)\OBEventReceiver.h
	-del OBEventReceiver_skel.cpp -del $(HDIR)\OBEventReceiver_skel.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB --dll-import \
	OB_EVENT_IMPORT $(IDLDIR)\OBEventReceiver.idl
	move OBEventReceiver.h $(HDIR)
	move OBEventReceiver_skel.h $(HDIR)

OBEventReceiver_skel.cpp $(HDIR)\OBEventReceiver_skel.h: OBEventReceiver.cpp

EventMsg.rc : EventMsg.mc
	mc EventMsg.mc

EventMsg.res: EventMsg.rc
	rc -r -fo EventMsg.res EventMsg.rc

EventMsg.h : EventMsg.rc

NTServiceMain : NTEventService.h

NTEventService.cpp : EventMsg.h NTEventService.h \
		EventChannelFactory_impl.h TypedEventChannelFactory_impl.h \
		EC_EventChannel_impl.h TEC_TypedEventChannel_impl.h

Config.h:
	echo /* dummy file */ > $@

#
# Work around the inference rules problem with nmake.
#
!ifndef BUILD_STAGE

install:: all

all depend install clean test::
    $(MAKE) /f Makefile.mak BUILD_STAGE=1 $@

!elseif $(BUILD_STAGE) == 1

install:: all

all depend install clean test::
    $(MAKE) /f Makefile.mak BUILD_STAGE=2 $@


!elseif $(BUILD_STAGE) == 2

install:: all

all depend install clean test::
    $(MAKE) /f Makefile.mak BUILD_STAGE=3 $@

!elseif $(BUILD_STAGE) == 3

install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(LIB_PDB_NAME) \
        copy $(LIB_PDB_NAME) $(libdir)
	copy $(SKELLIB_NAME) $(libdir)
	if exist $(SKELLIB_PDB_NAME) \
        copy $(SKELLIB_PDB_NAME) $(libdir)
	copy $(SERVLIB_NAME) $(libdir)
	if exist $(SERVLIB_PDB_NAME) \
        copy $(SERVLIB_PDB_NAME) $(libdir)
	copy $(SERVER_NAME) $(bindir)
	copy $(ADMIN_NAME) $(bindir)
	copy $(SERVICE_NAME) $(bindir)

!if "$(DLL)" == "yes"

LIB_DLL_PDB = $(LIB_DLL_NAME:.dll=.pdb)

SKELLIB_DLL_PDB = $(SKELLIB_DLL_NAME:.dll=.pdb)

SERVLIB_DLL_PDB = $(SERVLIB_DLL_NAME:.dll=.pdb)

install:: all
	copy $(LIB_DLL_NAME) $(libdir)
	copy $(LIB_EXP_NAME) $(libdir)
	if exist $(LIB_DLL_PDB) copy $(LIB_DLL_PDB) $(libdir)
	copy $(SKELLIB_DLL_NAME) $(libdir)
	copy $(SKELLIB_EXP_NAME) $(libdir)
	if exist $(SKELLIB_DLL_PDB) copy $(SKELLIB_DLL_PDB) $(libdir)
	copy $(SERVLIB_DLL_NAME) $(libdir)
	copy $(SERVLIB_EXP_NAME) $(libdir)
	if exist $(SERVLIB_DLL_PDB) copy $(SERVLIB_DLL_PDB) $(libdir)

!endif

clean::
	-del $(LIB_DLL_NAME) $(LIB_EXP_NAME) $(LIB_DEF_NAME) \
	$(LIB_DLL_NAME:.dll=.pdb) \
	$(SKELLIB_DLL_NAME) $(SKELLIB_EXP_NAME) $(SKELLIB_DEF_NAME) \
	$(SKELLIB_DLL_NAME:.dll=.pdb) \
	$(SERVLIB_DLL_NAME) $(SERVLIB_EXP_NAME) $(SERVLIB_DEF_NAME) \
	$(SERVLIB_DLL_NAME:.dll=.pdb)

clean::
	-del $(SERVICE_NAME) $(SERVICE_NAME:.exe=.pdb)

!endif

min:: all

install_min:: install

!include .windep
