// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// *********************************************************************

#ifndef PROPAGATOR_BASE_THREAD_H
#define PROPAGATOR_BASE_THREAD_H

//
// This class provides a base class for those threads that push and
// pull events.
//
class PropagatorBaseThread : public JTCThread, public JTCMonitor
{
    CORBA::ULong maxRetries_; // Max retries.
    
    CORBA::ULong retryTimeout_; // Initial timeout (msec).
    
    CORBA::Double retryMultiplier_; // Retry multiplier (msec).

    CORBA::ULong retry_; // Number of msec for next retry.
    
    CORBA::ULong retries_; // Number of retries.

protected:

    bool done_; // Are we done?

    CORBA::ULong id_; // The proxy id.

    OB::EventLogger_var logger_; // The Logger

    //
    // Run the retry algorithm.
    //
    bool retry();

    //
    // Delay for msecs.
    //
    void delay(CORBA::ULong);

    //
    // Reset the retry algorithm.
    //
    void resetRetry();

public:

    PropagatorBaseThread(OB::EventLogger_ptr, CORBA::ULong, CORBA::ULong,
    			 CORBA::ULong, CORBA::Double);
    virtual ~PropagatorBaseThread();

    //
    // Stop the thread.
    //
    void halt();
};

#endif
