# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

#
# Three libraries are created. CosNaming is for end-users, OBNaming and
# OBNamingService are for the applications that need to actually include
# an implementation of the service.
#
LIB_NAME	= $(top_srcdir)\lib\CosNaming$(LIBSUFFIX).lib
SKELLIB_NAME	= $(top_srcdir)\lib\OBNaming$(LIBSUFFIX).lib
SERVLIB_NAME	= $(top_srcdir)\lib\OBNamingService$(LIBSUFFIX).lib

LIB_PDB_NAME	= $(top_srcdir)\lib\CosNaming$(LIBSUFFIX).pdb
SKELLIB_PDB_NAME= $(top_srcdir)\lib\OBNaming$(LIBSUFFIX).pdb
SERVLIB_PDB_NAME= $(top_srcdir)\lib\OBNamingService$(LIBSUFFIX).pdb

ADMIN_NAME	= $(top_srcdir)\bin\nsadmin.exe
SERVER_NAME	= $(top_srcdir)\bin\nameserv.exe

UTILS           = $(SERVER_NAME) \
		  $(ADMIN_NAME) 

#
# Work around the inference rules problem with nmake.
#
!if !defined(BUILD_STAGE)

PDB_FLAGS       = /Fd$(LIB_PDB_NAME)

TARGETS		= $(LIB_NAME)

!elseif $(BUILD_STAGE) == 1

PDB_FLAGS   	= /Fd$(SKELLIB_PDB_NAME)
TARGETS		= $(SKELLIB_NAME)

!elseif $(BUILD_STAGE) == 2

PDB_FLAGS   	= /Fd$(SERVLIB_PDB_NAME)
TARGETS		= $(SERVLIB_NAME)

!elseif $(BUILD_STAGE) == 3

TARGETS		= $(UTILS)
PDB_FILES       = $(UTILS:.exe=.pdb) \
		  $(LIB_PDB_NAME) \
		  $(SKELLIB_PDB_NAME) \
		  $(SERVLIB_PDB_NAME)

!endif

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl\OB
HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= CosNaming.obj \
		  CosNaming_skel.obj \
		  BindingListener.obj \
		  BindingListener_skel.obj \
		  OBNaming.obj

#
# SKELLIB includes LIB_OBJS plus the missing _skel files
#
SKELLIB_OBJS   = OBNaming_skel.obj

SERVLIB_OBJS	= Types.obj \
		  OBNaming_impl.obj \
		  NamingDatabase.obj \
		  Compactor.obj \
		  NamingService.obj

SERVER_OBJS	= Server.obj

ADMIN_OBJS	= NSAdmin.obj

SERVICE_NAME    = $(top_srcdir)\bin\ntnameservice.exe

SERVICE_OBJS	= NTNamingService.obj \
		  NTServiceMain.obj \
		  NamingMsg.res

#
# When not in DLL mode these symbols are also needed for clean target
#
LIB_DEF_NAME	= CosNaming$(LIBSUFFIX).def
LIB_DLL_NAME    = $(top_srcdir)\lib\CosNaming$(OB_LIBVER)$(LIBSUFFIX).dll
LIB_EXP_NAME    = $(top_srcdir)\lib\CosNaming$(LIBSUFFIX).exp

SKELLIB_DEF_NAME= OBNaming$(LIBSUFFIX).def
SKELLIB_DLL_NAME= $(top_srcdir)\lib\OBNaming$(OB_LIBVER)$(LIBSUFFIX).dll
SKELLIB_EXP_NAME= $(top_srcdir)\lib\OBNaming$(LIBSUFFIX).exp

SERVLIB_DEF_NAME= OBNamingService$(LIBSUFFIX).def
SERVLIB_DLL_NAME= $(top_srcdir)\lib\OBNamingService$(OB_LIBVER)$(LIBSUFFIX).dll
SERVLIB_EXP_NAME= $(top_srcdir)\lib\OBNamingService$(LIBSUFFIX).exp

ALL_CPPFLAGS	= /I. /I$(top_srcdir)\include $(OB_CPPFLAGS) $(CPPFLAGS)

DLL_CPPFLAGS = /DOB_NAMING_IMPORT=/**/

!if !defined(BUILD_STAGE)

ALL_CPPFLAGS = $(DLL_CPPFLAGS) $(ALL_CPPFLAGS)

!elseif $(BUILD_STAGE) == 1

ALL_CPPFLAGS = $(DLL_CPPFLAGS) $(ALL_CPPFLAGS)

!endif

!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS) 

ALL_DLLLIBS	= $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(LIB_NAME): $(LIB_DLL_NAME)

$(SKELLIB_NAME): $(SKELLIB_DLL_NAME)

$(SERVLIB_NAME): $(SERVLIB_DLL_NAME)

$(LIB_DEF_NAME):

$(SKELLIB_DEF_NAME):

$(SERVLIB_DEF_NAME):

$(LIB_DLL_NAME): $(LIB_OBJS) $(LIB_DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(LIB_DEF_NAME) \
	CosNaming$(OB_LIBVER)$(LIBSUFFIX) $(LIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x54000000 /def:$(LIB_DEF_NAME) \
	/IMPLIB:$(LIB_NAME) /out:$@ $(LIB_OBJS) $(ALL_DLLLIBS)

$(SKELLIB_DLL_NAME): $(SKELLIB_OBJS) $(LIB_OBJS) $(SKELLIB_DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(SKELLIB_DEF_NAME) \
	OBNaming$(OB_LIBVER)$(LIBSUFFIX) $(SKELLIB_OBJS) $(LIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x54C00000 /def:$(SKELLIB_DEF_NAME) \
	/IMPLIB:$(SKELLIB_NAME) /out:$@ $(SKELLIB_OBJS) $(LIB_OBJS) \
	$(ALL_DLLLIBS)

$(SERVLIB_DLL_NAME): $(SERVLIB_OBJS) $(SERVLIB_DEF_NAME) $(SKELLIB_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(SERVLIB_DEF_NAME) \
	OBNamingService$(OB_LIBVER)$(LIBSUFFIX) $(SERVLIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x54B00000 /def:$(SERVLIB_DEF_NAME) \
	/IMPLIB:$(SERVLIB_NAME) /out:$@ $(SERVLIB_OBJS) $(ALL_DLLLIBS) \
	$(SKELLIB_NAME)

!else

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)

$(LIB_NAME): $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SKELLIB_NAME): $(SKELLIB_OBJS) $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(SKELLIB_OBJS) $(LIB_OBJS)

$(SERVLIB_NAME): $(SERVLIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(SERVLIB_OBJS)

!endif

ALL_LIBS = $(SERVLIB_NAME) $(SKELLIB_NAME) $(OB_LIBS) $(LIBS)

$(SERVER_NAME): $(SERVER_OBJS) $(SKELLIB_NAME) $(SERVLIB_NAME)
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ \
	$(SERVER_OBJS) $(ALL_LIBS)

$(SERVICE_NAME): $(SERVICE_OBJS) $(SKELLIB_NAME) $(SERVLIB_NAME) Config.h
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ $(SERVICE_OBJS) $(ALL_LIBS)

!ifdef BUILD_STAGE

!if $(BUILD_STAGE) == 3

all:: $(SERVICE_NAME)

!endif

!endif

$(ADMIN_NAME): $(ADMIN_OBJS) $(LIB_NAME)
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ \
	$(ADMIN_OBJS) $(LIB_NAME) $(OB_LIBS) $(LIBS)

CosNaming.cpp $(HDIR)\CosNaming.h: $(IDLDIR)\CosNaming.idl
	-del CosNaming.cpp $(HDIR)\CosNaming.h
	-del CosNaming_skel.cpp $(HDIR)\CosNaming_skel.h
	$(IDL) --header-dir OB --dll-import OB_NAMING_IMPORT \
	$(IDLDIR)\CosNaming.idl
	move CosNaming.h $(HDIR)
	move CosNaming_skel.h $(HDIR)

CosNaming_skel.cpp $(HDIR)\CosNaming_skel.h: CosNaming.cpp

Types.cpp Types.h: Types.idl
	-del Types.cpp Types.h
	$(IDL) -I$(top_srcdir)/idl --no-skeletons Types.idl

BindingListener.cpp $(HDIR)/BindingListener.h: $(IDLDIR)/BindingListener.idl
	-del BindingListener.cpp $(HDIR)\BindingListener.h
	-del BindingListener_skel.cpp $(HDIR)\BindingListener_skel.h
	$(IDL) -I$(top_srcdir)/idl --this-header-dir OB \
	--dll-import OB_NAMING_IMPORT $(IDLDIR)/BindingListener.idl
	move BindingListener.h $(HDIR)
	move BindingListener_skel.h $(HDIR)

OBNaming.cpp $(HDIR)/OBNaming.h: $(IDLDIR)/OBNaming.idl
	-del OBNaming.cpp $(HDIR)\OBNaming.h
	-del OBNaming_skel.cpp $(HDIR)\OBNaming_skel.h
	$(IDL) -I$(top_srcdir)/idl --this-header-dir OB \
	--dll-import OB_NAMING_IMPORT $(IDLDIR)/OBNaming.idl
	move OBNaming.h $(HDIR)
	move OBNaming_skel.h $(HDIR)

NamingMsg.rc : NamingMsg.mc
	mc NamingMsg.mc

NamingMsg.res: NamingMsg.rc
	rc -r -fo NamingMsg.res NamingMsg.rc

NamingMsg.h : NamingMsg.rc

NTServiceMain.cpp : NTNamingService.h

NTNamingService.cpp : NamingMsg.h NTNamingService.h OBNaming_impl.h \
                      NamingDatabase.h Compactor.h Types.h

Config.h:
	echo /* dummy file */ > $@

#
# Work around the inference rules problem with nmake.
#
!ifndef BUILD_STAGE

install:: all

all depend install clean test::
    $(MAKE) /f Makefile.mak BUILD_STAGE=1 $@

!elseif $(BUILD_STAGE) == 1

install_min:: install

all depend install clean test::
    $(MAKE) /f Makefile.mak BUILD_STAGE=2 $@


!elseif $(BUILD_STAGE) == 2

install:: all

all depend install clean test::
    $(MAKE) /f Makefile.mak BUILD_STAGE=3 $@

!elseif $(BUILD_STAGE) == 3

install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(LIB_PDB_NAME) copy $(LIB_PDB_NAME) $(libdir)
	copy $(SKELLIB_NAME) $(libdir)
	if exist $(SKELLIB_PDB_NAME) copy $(SKELLIB_PDB_NAME) $(libdir)
	copy $(SERVLIB_NAME) $(libdir)
	if exist $(SERVLIB_PDB_NAME) copy $(SERVLIB_PDB_NAME) $(libdir)
	copy $(SERVER_NAME) $(bindir)
	copy $(ADMIN_NAME) $(bindir)
	copy $(SERVICE_NAME) $(bindir)

!if "$(DLL)" == "yes"

LIB_DLL_PDB = $(LIB_DLL_NAME:.dll=.pdb)

SKELLIB_DLL_PDB = $(SKELLIB_DLL_NAME:.dll=.pdb)

SERVLIB_DLL_PDB = $(SERVLIB_DLL_NAME:.dll=.pdb)

install:: all
	copy $(LIB_DLL_NAME) $(libdir)
	copy $(LIB_EXP_NAME) $(libdir)
	if exist $(LIB_DLL_PDB) copy $(LIB_DLL_PDB) $(libdir)
	copy $(SKELLIB_DLL_NAME) $(libdir)
	copy $(SKELLIB_EXP_NAME) $(libdir)
	if exist $(SKELLIB_DLL_PDB) copy $(SKELLIB_DLL_PDB) $(libdir)
	copy $(SERVLIB_DLL_NAME) $(libdir)
	copy $(SERVLIB_EXP_NAME) $(libdir)
	if exist $(SERVLIB_DLL_PDB) copy $(SERVLIB_DLL_PDB) $(libdir)

!endif

clean::
	-del $(LIB_DLL_NAME) $(LIB_EXP_NAME) $(LIB_DEF_NAME) \
	$(LIB_DLL_NAME:.dll=.pdb) \
	$(SKELLIB_DLL_NAME) $(SKELLIB_EXP_NAME) $(SKELLIB_DEF_NAME) \
	$(SKELLIB_DLL_NAME:.dll=.pdb) \
	$(SERVLIB_DLL_NAME) $(SERVLIB_EXP_NAME) $(SERVLIB_DEF_NAME) \
	$(SERVLIB_DLL_NAME:.dll=.pdb)

clean::
	-del $(SERVICE_NAME) $(SERVICE_NAME:.exe=.pdb)

!endif

min:: all

install_min:: install

!include .windep
