// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/Logger.h>

#include <Hello_impl.h>

Hello_impl::Hello_impl(
    CORBA::ORB_ptr orb,
    PortableServer::POA_ptr poa
)
    : orb_(CORBA::ORB::_duplicate(orb)),
      poa_(PortableServer::POA::_duplicate(poa))
{
    OBCORBA::ORB_var oborb = OBCORBA::ORB::_narrow(orb_);
    logger_ = oborb -> logger();
}

void
Hello_impl::say_hello()
    throw(CORBA::SystemException)
{
    logger_ -> info("Hello World!");
}

void
Hello_impl::shutdown()
    throw(CORBA::SystemException)
{
    logger_ -> info("Hello World Service - shutdown()");
    orb_ -> shutdown(false);
}

PortableServer::POA_ptr
Hello_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(poa_);
}
