// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <Example_skel.h>
#include <Example_impl.h>

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

//
// IDL:Example:1.0
//
Example_impl::Example_impl()
{
}

Example_impl::~Example_impl()
{
}

//
// IDL:Example/display:1.0
//
void
Example_impl::display(Describable_ptr d)
    throw(CORBA::SystemException)
{
    //
    // Obtain a description of the Describable object. If the object
    // is an object reference, then this will be a remote invocation.
    // Otherwise, if the object is a valuetype, this will be a
    // local operation.
    //
    CORBA::String_var desc = d -> get_description();

    //
    // For illustrative purposes, we discover whether the given
    // Describable object is an Account or a Currency
    //
    Account_var account = Account::_narrow(d);
    Currency* currency = Currency::_downcast(d);

    if(!CORBA::is_nil(account))
        cout << "Received an Account object: " << desc << endl;
    else if(currency != 0)
        cout << "Received a Currency object: " << desc << endl;
}
