// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <BasicTester_impl.h>

//
// Servant which implements the Benchmark::BasicTester interface.
//

//
// BasicTester_impl constructor
//
BasicTester_impl::BasicTester_impl(
    PortableServer::POA_ptr poa
) :
    m_poa(PortableServer::POA::_duplicate(poa))
{
}

//
// ~BasicTester_impl destructor.
//
BasicTester_impl::~BasicTester_impl()
{
}

PortableServer::POA_ptr
BasicTester_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(m_poa);
}

void
BasicTester_impl::ping()
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::short_in_t(CORBA::Short)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::short_out_t(CORBA::Short_out s)
    throw(CORBA::SystemException)
{
    s = (CORBA::Short) 7;
}

void
BasicTester_impl::short_inout_t(CORBA::Short& s)
    throw(CORBA::SystemException)
{
    s = (CORBA::Short) 44;
}

CORBA::Short
BasicTester_impl::short_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::Short) 19;
}

void
BasicTester_impl::long_in_t(CORBA::Long)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::long_out_t(CORBA::Long_out l)
    throw(CORBA::SystemException)
{
    l = (CORBA::Long) 88884;
}

void
BasicTester_impl::long_inout_t(CORBA::Long& l)
    throw(CORBA::SystemException)
{
    l = (CORBA::Long) 99;
}

CORBA::Long
BasicTester_impl::long_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::Long) 88;
}

void
BasicTester_impl::longlong_in_t(CORBA::LongLong)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::longlong_out_t(CORBA::LongLong_out ll)
    throw(CORBA::SystemException)
{
#ifdef HAVE_VCPLUSPLUS_BUGS
    ll = (CORBA::LongLong) 8888839234L;
#else
    ll = (CORBA::LongLong) 8888839234LL;
#endif
}

void
BasicTester_impl::longlong_inout_t(CORBA::LongLong& ll)
    throw(CORBA::SystemException)
{
    ll = (CORBA::LongLong) 88;
}

CORBA::LongLong
BasicTester_impl::longlong_ret_t()
    throw(CORBA::SystemException)
{
#ifdef HAVE_VCPLUSPLUS_BUGS
    return (CORBA::LongLong) 9234098234L;
#else
    return (CORBA::LongLong) 9234098234LL;
#endif
}

void
BasicTester_impl::ushort_in_t(CORBA::UShort)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::ushort_out_t(CORBA::UShort_out us)
    throw(CORBA::SystemException)
{
    us = (CORBA::UShort) 7;
}

void
BasicTester_impl::ushort_inout_t(CORBA::UShort& us)
    throw(CORBA::SystemException)
{
    us = (CORBA::UShort) 8883;
}

CORBA::UShort
BasicTester_impl::ushort_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::UShort) 88;
}

void
BasicTester_impl::ulong_in_t(CORBA::ULong)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::ulong_out_t(CORBA::ULong_out ul)
    throw(CORBA::SystemException)
{
    ul = (CORBA::ULong) 1234890;
}

void
BasicTester_impl::ulong_inout_t(CORBA::ULong& ul)
    throw(CORBA::SystemException)
{
    ul = (CORBA::ULong) 1230498;

}

CORBA::ULong
BasicTester_impl::ulong_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::ULong) 439402;
}

void
BasicTester_impl::ulonglong_in_t(CORBA::ULongLong)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::ulonglong_out_t(CORBA::ULongLong_out ull)
    throw(CORBA::SystemException)
{
#ifdef HAVE_VCPLUSPLUS_BUGS
    ull = (CORBA::ULongLong) 9940202394L;
#else
    ull = (CORBA::ULongLong) 9940202394LL;
#endif
}

void
BasicTester_impl::ulonglong_inout_t(CORBA::ULongLong& ull)
    throw(CORBA::SystemException)
{
#ifdef HAVE_VCPLUSPLUS_BUGS
    ull = (CORBA::ULongLong) 999293024L;
#else
    ull = (CORBA::ULongLong) 999293024LL;
#endif
}

CORBA::ULongLong
BasicTester_impl::ulonglong_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::ULongLong) 8882923;
}

void
BasicTester_impl::float_in_t(CORBA::Float)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::float_out_t(CORBA::Float_out f)
    throw(CORBA::SystemException)
{
    f = (CORBA::Float) 7888.4;
}

void
BasicTester_impl::float_inout_t(CORBA::Float& f)
    throw(CORBA::SystemException)
{
    f = (CORBA::Float) 9994.99323434;
}

CORBA::Float
BasicTester_impl::float_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::Float) 883.779023;
}

void
BasicTester_impl::double_in_t(CORBA::Double)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::double_out_t(CORBA::Double_out d)
    throw(CORBA::SystemException)
{
    d = (CORBA::Double) 88888234.882030948;
}

void
BasicTester_impl::double_inout_t(CORBA::Double& d)
    throw(CORBA::SystemException)
{
    d = (CORBA::Double) 1234.4523409;
}

CORBA::Double
BasicTester_impl::double_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::Double) 88234.333234;
}

/*
void
BasicTester_impl::longdouble_in_t(CORBA::LongDouble ld)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::longdouble_out_t(CORBA::LongDouble_out ld)
    throw(CORBA::SystemException)
{
     ld = (CORBA::LongDouble) 9992340324.23409234;
}

void
BasicTester_impl::longdouble_inout_t(CORBA::LongDouble& ld)
    throw(CORBA::SystemException)
{
     ld = (CORBA::LongDouble) 23948029834.234029384;
}

CORBA::LongDouble
BasicTester_impl::longdouble_ret_t()
    throw(CORBA::SystemException)
{
     return (CORBA::LongDouble) 923849823.234987234;
}
*/

void
BasicTester_impl::char_in_t(CORBA::Char)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::char_out_t(CORBA::Char_out c)
    throw(CORBA::SystemException)
{
    c = (CORBA::Char) 'f';
}

void
BasicTester_impl::char_inout_t(CORBA::Char& c)
    throw(CORBA::SystemException)
{
    c = (CORBA::Char) 'M';
}

CORBA::Char
BasicTester_impl::char_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::Char) 'v';
}

void
BasicTester_impl::wchar_in_t(CORBA::WChar)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::wchar_out_t(CORBA::WChar_out wc)
    throw(CORBA::SystemException)
{
    wc = (CORBA::WChar) L'z';
}

void
BasicTester_impl::wchar_inout_t(CORBA::WChar& wc)
    throw(CORBA::SystemException)
{
    wc = (CORBA::WChar) L'F';
}

CORBA::WChar
BasicTester_impl::wchar_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::WChar) L'Q';
}

void
BasicTester_impl::string_in_t(const char*)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::string_out_t(CORBA::String_out s)
    throw(CORBA::SystemException)
{
    s = CORBA::string_dup("Howdy");
}

void
BasicTester_impl::string_inout_t(char*& s)
    throw(CORBA::SystemException)
{
    s = CORBA::string_dup("Pardner");
}

char*
BasicTester_impl::string_ret_t()
    throw(CORBA::SystemException)
{
    return CORBA::string_dup("Yowza");
}

void
BasicTester_impl::wstring_in_t(const CORBA::WChar*)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::wstring_out_t(CORBA::WString_out ws)
    throw(CORBA::SystemException)
{
    ws = CORBA::wstring_dup(L"Phlogiston");
}

void
BasicTester_impl::wstring_inout_t(CORBA::WChar*& ws)
    throw(CORBA::SystemException)
{
    ws = CORBA::wstring_dup(L"Ether");
}

CORBA::WChar*
BasicTester_impl::wstring_ret_t()
    throw(CORBA::SystemException)
{
    return CORBA::wstring_dup(L"Ray gun");
}

void
BasicTester_impl::boolean_in_t(CORBA::Boolean)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::boolean_out_t(CORBA::Boolean_out b)
    throw(CORBA::SystemException)
{
    b = (CORBA::Boolean) true;
}

void
BasicTester_impl::boolean_inout_t(CORBA::Boolean& b)
    throw(CORBA::SystemException)
{
    b = (CORBA::Boolean) false;
}

CORBA::Boolean
BasicTester_impl::boolean_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::Boolean) true;
}

void
BasicTester_impl::octet_in_t(CORBA::Octet)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::octet_out_t(CORBA::Octet_out o)
    throw(CORBA::SystemException)
{
    o = (CORBA::Octet) 7;
}

void
BasicTester_impl::octet_inout_t(CORBA::Octet& o)
    throw(CORBA::SystemException)
{
    o = (CORBA::Octet) 0;
}

CORBA::Octet
BasicTester_impl::octet_ret_t()
    throw(CORBA::SystemException)
{
    return (CORBA::Octet) 14;
}

void
BasicTester_impl::any_in_t(const CORBA::Any&)
    throw(CORBA::SystemException)
{
}

void
BasicTester_impl::any_out_t(CORBA::Any_out a)
    throw(CORBA::SystemException)
{
    CORBA::Any_var any = new CORBA::Any;
    any.inout() <<= (CORBA::Float) 44.44;
    a = any._retn();
}

void
BasicTester_impl::any_inout_t(CORBA::Any& a)
    throw(CORBA::SystemException)
{
    a <<= (CORBA::Double) 44234.88234;
}

CORBA::Any*
BasicTester_impl::any_ret_t()
    throw(CORBA::SystemException)
{
    CORBA::Any_var result = new CORBA::Any(); // allocate memory;
    result <<= (CORBA::Short) 4;

    return result._retn();
}
