// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************/*

#include <OB/CORBA.h>

#include <Benchmark.h>
#include <CallBasicTester.h>
#include <CallUserTypeTester.h>
#include <CallSequenceTester.h>

#include <stdlib.h>

#ifdef HAVE_FSTREAM
#   include <fstream>
#else
#   include <fstream.h>
#endif

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif


int
run(CORBA::ORB_ptr orb, int /* argc */, char*[])
{
    long iterations = 1000;

    try
    {
	//
        // Exercise interface Benchmark::BasicTester.
        //
	CORBA::Object_var obj =
	    orb -> string_to_object("relfile:/Benchmark_BasicTester.ref");
        Benchmark::BasicTester_var basicTester =
            Benchmark::BasicTester::_narrow(obj);
        if(CORBA::is_nil(basicTester)) 
        {
            cerr << "Could not narrow reference to interface "
                 << "Benchmark::BasicTester" << endl;
        }
        else 
        {
	    CallBasicTester callBasicTester;
            callBasicTester.ping(basicTester, iterations);
            callBasicTester.short_in_t(basicTester, iterations);
            callBasicTester.short_out_t(basicTester, iterations);
            callBasicTester.short_inout_t(basicTester, iterations);
            callBasicTester.short_ret_t(basicTester, iterations);
            callBasicTester.long_in_t(basicTester, iterations);
            callBasicTester.long_out_t(basicTester, iterations);
            callBasicTester.long_inout_t(basicTester, iterations);
            callBasicTester.long_ret_t(basicTester, iterations);
            callBasicTester.longlong_in_t(basicTester, iterations);
            callBasicTester.longlong_out_t(basicTester, iterations);
            callBasicTester.longlong_inout_t(basicTester, iterations);
            callBasicTester.longlong_ret_t(basicTester, iterations);
            callBasicTester.ushort_in_t(basicTester, iterations);
            callBasicTester.ushort_out_t(basicTester, iterations);
            callBasicTester.ushort_inout_t(basicTester, iterations);
            callBasicTester.ushort_ret_t(basicTester, iterations);
            callBasicTester.ulong_in_t(basicTester, iterations);
            callBasicTester.ulong_out_t(basicTester, iterations);
            callBasicTester.ulong_inout_t(basicTester, iterations);
            callBasicTester.ulong_ret_t(basicTester, iterations);
            callBasicTester.ulonglong_in_t(basicTester, iterations);
            callBasicTester.ulonglong_out_t(basicTester, iterations);
            callBasicTester.ulonglong_inout_t(basicTester, iterations);
            callBasicTester.ulonglong_ret_t(basicTester, iterations);
            callBasicTester.float_in_t(basicTester, iterations);
            callBasicTester.float_out_t(basicTester, iterations);
            callBasicTester.float_inout_t(basicTester, iterations);
            callBasicTester.float_ret_t(basicTester, iterations);
            callBasicTester.double_in_t(basicTester, iterations);
            callBasicTester.double_out_t(basicTester, iterations);
            callBasicTester.double_inout_t(basicTester, iterations);
            callBasicTester.double_ret_t(basicTester, iterations);
            callBasicTester.char_in_t(basicTester, iterations);
            callBasicTester.char_out_t(basicTester, iterations);
            callBasicTester.char_inout_t(basicTester, iterations);
            callBasicTester.char_ret_t(basicTester, iterations);
            callBasicTester.wchar_in_t(basicTester, iterations);
            callBasicTester.wchar_out_t(basicTester, iterations);
            callBasicTester.wchar_inout_t(basicTester, iterations);
            callBasicTester.wchar_ret_t(basicTester, iterations);
            callBasicTester.string_in_t(basicTester, iterations);
            callBasicTester.string_out_t(basicTester, iterations);
            callBasicTester.string_inout_t(basicTester, iterations);
            callBasicTester.string_ret_t(basicTester, iterations);
            callBasicTester.wstring_in_t(basicTester, iterations);
            callBasicTester.wstring_out_t(basicTester, iterations);
            callBasicTester.wstring_inout_t(basicTester, iterations);
            callBasicTester.wstring_ret_t(basicTester, iterations);
            callBasicTester.boolean_in_t(basicTester, iterations);
            callBasicTester.boolean_out_t(basicTester, iterations);
            callBasicTester.boolean_inout_t(basicTester, iterations);
            callBasicTester.boolean_ret_t(basicTester, iterations);
            callBasicTester.octet_in_t(basicTester, iterations);
            callBasicTester.octet_out_t(basicTester, iterations);
            callBasicTester.octet_inout_t(basicTester, iterations);
            callBasicTester.octet_ret_t(basicTester, iterations);
            callBasicTester.any_in_t(basicTester, iterations);
            callBasicTester.any_out_t(basicTester, iterations);
            callBasicTester.any_inout_t(basicTester, iterations);
            callBasicTester.any_ret_t(basicTester, iterations);
        }

	//
        // Exercise interface Benchmark::UserTypeTester.
        //
        obj = orb -> string_to_object("relfile:/Benchmark_UserTypeTester.ref");
        Benchmark::UserTypeTester_var userTypeTester =
            Benchmark::UserTypeTester::_narrow(obj);
        if(CORBA::is_nil(userTypeTester)) 
        {
            cerr << "Could not narrow reference to interface "
                 << "Benchmark::UserTypeTester" << endl;
        }
        else 
        {
	    CallUserTypeTester callUserTypeTester;
            callUserTypeTester.u1_in_t(userTypeTester, iterations);
            callUserTypeTester.u1_out_t(userTypeTester, iterations);
            callUserTypeTester.u1_inout_t(userTypeTester, iterations);
            callUserTypeTester.u1_ret_t(userTypeTester, iterations);
            callUserTypeTester.u2_in_t(userTypeTester, iterations);
            callUserTypeTester.u2_out_t(userTypeTester, iterations);
            callUserTypeTester.u2_inout_t(userTypeTester, iterations);
            callUserTypeTester.u2_ret_t(userTypeTester, iterations);
            callUserTypeTester.s1_in_t(userTypeTester, iterations);
            callUserTypeTester.s1_out_t(userTypeTester, iterations);
            callUserTypeTester.s1_inout_t(userTypeTester, iterations);
            callUserTypeTester.s1_ret_t(userTypeTester, iterations);
            callUserTypeTester.s2_in_t(userTypeTester, iterations);
            callUserTypeTester.s2_out_t(userTypeTester, iterations);
            callUserTypeTester.s2_inout_t(userTypeTester, iterations);
            callUserTypeTester.s2_ret_t(userTypeTester, iterations);
            callUserTypeTester.interface_in_t(userTypeTester, iterations);
            callUserTypeTester.interface_out_t(userTypeTester, iterations);
            callUserTypeTester.interface_inout_t(userTypeTester, iterations);
            callUserTypeTester.interface_ret_t(userTypeTester, iterations);
        }

	//
        // Exercise interface Benchmark::SequenceTester.
        //
        obj = orb -> string_to_object("relfile:/Benchmark_SequenceTester.ref");
        Benchmark::SequenceTester_var sequenceTester =
            Benchmark::SequenceTester::_narrow(obj);
        if(CORBA::is_nil(sequenceTester)) 
        {
            cerr << "Could not narrow reference to interface "
                 << "Benchmark::SequenceTester" << endl;
        }
        else 
        {
	    CallSequenceTester callSequenceTester;
            callSequenceTester.ShortSeq_UB_in_t(sequenceTester, iterations);
            callSequenceTester.ShortSeq_UB_out_t(sequenceTester, iterations);
            callSequenceTester.ShortSeq_UB_inout_t(sequenceTester, iterations);
            callSequenceTester.ShortSeq_UB_ret_t(sequenceTester, iterations);
            callSequenceTester.FloatSeq_64K_in_t(sequenceTester,
	    					iterations / 100);
            callSequenceTester.FloatSeq_64K_out_t(sequenceTester,
	    					iterations / 100);
            callSequenceTester.FloatSeq_64K_inout_t(sequenceTester,
	    					iterations / 100);
            callSequenceTester.FloatSeq_64K_ret_t(sequenceTester,
	    					iterations / 100);
            callSequenceTester.StringSeq_UB_in_t(sequenceTester, iterations);
            callSequenceTester.StringSeq_UB_out_t(sequenceTester, iterations);
            callSequenceTester.StringSeq_UB_inout_t(sequenceTester,
	    					iterations);
            callSequenceTester.StringSeq_UB_ret_t(sequenceTester, iterations);
            callSequenceTester.OctetSeq_1M_in_t(sequenceTester,
	    					iterations / 100);
            callSequenceTester.OctetSeq_1M_out_t(sequenceTester,
	    					iterations / 100);
            callSequenceTester.OctetSeq_1M_inout_t(sequenceTester,
	    					iterations / 100);
            callSequenceTester.OctetSeq_1M_ret_t(sequenceTester,
	    					iterations / 100);
            callSequenceTester.AnySeq_UB_in_t(sequenceTester, iterations);
            callSequenceTester.AnySeq_UB_out_t(sequenceTester, iterations);
            callSequenceTester.AnySeq_UB_inout_t(sequenceTester, iterations);
            callSequenceTester.AnySeq_UB_ret_t(sequenceTester, iterations);
            callSequenceTester.U2Seq_UB_in_t(sequenceTester, iterations);
            callSequenceTester.U2Seq_UB_out_t(sequenceTester, iterations);
            callSequenceTester.U2Seq_UB_inout_t(sequenceTester, iterations);
            callSequenceTester.U2Seq_UB_ret_t(sequenceTester, iterations);
            callSequenceTester.S2Seq_UB_in_t(sequenceTester, iterations);
            callSequenceTester.S2Seq_UB_out_t(sequenceTester, iterations);
            callSequenceTester.S2Seq_UB_inout_t(sequenceTester, iterations);
            callSequenceTester.S2Seq_UB_ret_t(sequenceTester, iterations);
            callSequenceTester.InterfaceSeq_in_t(sequenceTester, iterations);
            callSequenceTester.InterfaceSeq_out_t(sequenceTester, iterations);
            callSequenceTester.InterfaceSeq_inout_t(sequenceTester,
	    					iterations);
            callSequenceTester.InterfaceSeq_ret_t(sequenceTester, iterations);
        }

	cout << "done." << endl;
    }
    catch(const CORBA::Exception &ex) 
    {
        cerr << "Unexpected CORBA exception: " << ex << endl;
        return EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}

int
main(int argc, char* argv[], char*[])
{
    int status = EXIT_SUCCESS;
    CORBA::ORB_var orb;

    try
    {
        orb = CORBA::ORB_init(argc, argv, "Benchmark-Client");
        status = run(orb, argc, argv);
    }
    catch(const CORBA::Exception& ex)
    {
        cerr << ex << endl;
        status = EXIT_FAILURE;
    }

    if(!CORBA::is_nil(orb))
    {
        try
        {
            orb -> destroy();
        }
        catch(const CORBA::Exception& ex)
        {
            cerr << ex << endl;
            status = EXIT_FAILURE;
        }
    }

    return status;
}


