// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

//
// Class: SequenceTester_impl
// A POA servant which implements of the Benchmark::SequenceTester interface
//

#ifndef BENCHMARK_SEQUENCETESTERIMPL_H_
#define BENCHMARK_SEQUENCETESTERIMPL_H_

#include <Benchmark_skel.h>

class SequenceTester_impl :
    public virtual POA_Benchmark::SequenceTester,
    public PortableServer::RefCountServantBase
{
    PortableServer::POA_var m_poa;

public:

    SequenceTester_impl(
	PortableServer::POA_ptr poa
    );

    virtual ~SequenceTester_impl();

    virtual PortableServer::POA_ptr
    _default_POA();

    //
    // IDL operations
    //
    virtual void
    ShortSeq_UB_in_t(const Benchmark::SequenceTester::ShortSeq_UB& s_seq)
        throw(CORBA::SystemException);

    virtual void
    ShortSeq_UB_out_t(Benchmark::SequenceTester::ShortSeq_UB_out s_seq)
        throw(CORBA::SystemException);

    virtual void
    ShortSeq_UB_inout_t(Benchmark::SequenceTester::ShortSeq_UB& s_seq)
        throw(CORBA::SystemException);

    virtual Benchmark::SequenceTester::ShortSeq_UB*
    ShortSeq_UB_ret_t()
        throw(CORBA::SystemException);

    virtual void
    FloatSeq_64K_in_t(const Benchmark::SequenceTester::FloatSeq_64K& f_seq)
        throw(CORBA::SystemException);

    virtual void
    FloatSeq_64K_out_t(Benchmark::SequenceTester::FloatSeq_64K_out f_seq)
        throw(CORBA::SystemException);

    virtual void
    FloatSeq_64K_inout_t(Benchmark::SequenceTester::FloatSeq_64K& f_seq)
        throw(CORBA::SystemException);

    virtual Benchmark::SequenceTester::FloatSeq_64K*
    FloatSeq_64K_ret_t()
        throw(CORBA::SystemException);

    virtual void
    StringSeq_UB_in_t(const Benchmark::SequenceTester::StringSeq_UB& s_seq)
        throw(CORBA::SystemException);

    virtual void
    StringSeq_UB_out_t(Benchmark::SequenceTester::StringSeq_UB_out s_seq)
        throw(CORBA::SystemException);

    virtual void
    StringSeq_UB_inout_t(Benchmark::SequenceTester::StringSeq_UB& s_seq)
        throw(CORBA::SystemException);

    virtual Benchmark::SequenceTester::StringSeq_UB*
    StringSeq_UB_ret_t()
        throw(CORBA::SystemException);

    virtual void
    OctetSeq_1M_in_t(const Benchmark::SequenceTester::OctetSeq_1M& o_seq)
        throw(CORBA::SystemException);

    virtual void
    OctetSeq_1M_out_t(Benchmark::SequenceTester::OctetSeq_1M_out o_seq)
        throw(CORBA::SystemException);

    virtual void
    OctetSeq_1M_inout_t(Benchmark::SequenceTester::OctetSeq_1M& o_seq)
        throw(CORBA::SystemException);

    virtual Benchmark::SequenceTester::OctetSeq_1M*
    OctetSeq_1M_ret_t()
        throw(CORBA::SystemException);

    virtual void
    AnySeq_UB_in_t(const Benchmark::SequenceTester::AnySeq_UB& a_seq)
        throw(CORBA::SystemException);

    virtual void
    AnySeq_UB_out_t(Benchmark::SequenceTester::AnySeq_UB_out a_seq)
        throw(CORBA::SystemException);

    virtual void
    AnySeq_UB_inout_t(Benchmark::SequenceTester::AnySeq_UB& a_seq)
        throw(CORBA::SystemException);

    virtual Benchmark::SequenceTester::AnySeq_UB*
    AnySeq_UB_ret_t()
        throw(CORBA::SystemException);

    virtual void
    U2Seq_UB_in_t(const Benchmark::SequenceTester::U2Seq_UB& u2_seq)
        throw(CORBA::SystemException);

    virtual void
    U2Seq_UB_out_t(Benchmark::SequenceTester::U2Seq_UB_out u2_seq)
        throw(CORBA::SystemException);

    virtual void
    U2Seq_UB_inout_t(Benchmark::SequenceTester::U2Seq_UB& u2_seq)
        throw(CORBA::SystemException);

    virtual Benchmark::SequenceTester::U2Seq_UB*
    U2Seq_UB_ret_t()
        throw(CORBA::SystemException);

    virtual void
    S2Seq_UB_in_t(const Benchmark::SequenceTester::S2Seq_UB& s2_seq)
        throw(CORBA::SystemException);

    virtual void
    S2Seq_UB_out_t(Benchmark::SequenceTester::S2Seq_UB_out s2_seq)
        throw(CORBA::SystemException);

    virtual void
    S2Seq_UB_inout_t(Benchmark::SequenceTester::S2Seq_UB& s2_seq)
        throw(CORBA::SystemException);

    virtual Benchmark::SequenceTester::S2Seq_UB*
    S2Seq_UB_ret_t()
        throw(CORBA::SystemException);

    virtual void
    InterfaceSeq_in_t(const Benchmark::SequenceTester::InterfaceSeq& i_seq)
        throw(CORBA::SystemException);

    virtual void
    InterfaceSeq_out_t(Benchmark::SequenceTester::InterfaceSeq_out i_seq)
        throw(CORBA::SystemException);

    virtual void
    InterfaceSeq_inout_t(Benchmark::SequenceTester::InterfaceSeq& i_seq)
        throw(CORBA::SystemException);

    virtual Benchmark::SequenceTester::InterfaceSeq*
    InterfaceSeq_ret_t()
        throw(CORBA::SystemException);

private: 

    //
    // The following are not implemented
    //
    SequenceTester_impl(const SequenceTester_impl &);
    SequenceTester_impl& operator=(const SequenceTester_impl &);

    CORBA::Short*          m_shortseq_buf;
    CORBA::Float*          m_floatseq_buf;
    char**                 m_stringseq_buf;
    CORBA::Octet*          m_octetseq_buf;
    CORBA::Any*            m_anyseq_buf;
    UserTypes::u2*         m_u2seq_buf;
    UserTypes::s2*         m_s2seq_buf;
    UserTypes::I_ptr*      m_Interfaceseq_buf;
}; 

#endif
