// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <UserTypeTester_impl.h>

//
// Servant which implements the Benchmark::UserTypeTester interface.
//

//
// UserTypeTester_impl constructor
//
//
UserTypeTester_impl::UserTypeTester_impl(
    PortableServer::POA_ptr poa
) :
    m_poa(PortableServer::POA::_duplicate(poa))
{
}

//
// ~UserTypeTester_impl destructor.
//
UserTypeTester_impl::~UserTypeTester_impl()
{
}

PortableServer::POA_ptr
UserTypeTester_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(m_poa);
}

void
UserTypeTester_impl::u1_in_t(const UserTypes::u1&)
    throw(CORBA::SystemException)
{
}

void
UserTypeTester_impl::u1_out_t(UserTypes::u1_out u)
    throw(CORBA::SystemException)
{
    u.s(9);
}

void
UserTypeTester_impl::u1_inout_t(UserTypes::u1& u)
    throw(CORBA::SystemException)
{
    u.l(10);
}

UserTypes::u1
UserTypeTester_impl::u1_ret_t()
    throw(CORBA::SystemException)
{
    UserTypes::u1 result;

    result.c('q');

    return result;
}

void
UserTypeTester_impl::u2_in_t(const UserTypes::u2&)
    throw(CORBA::SystemException)
{
}

void
UserTypeTester_impl::u2_out_t(UserTypes::u2_out u)
    throw(CORBA::SystemException)
{
    u = new UserTypes::u2; // allocate memory
    u -> ll(523);
}

void
UserTypeTester_impl::u2_inout_t(UserTypes::u2& u)
    throw(CORBA::SystemException)
{
    u.o ((CORBA::Octet) 7);

}

UserTypes::u2*
UserTypeTester_impl::u2_ret_t()
    throw(CORBA::SystemException)
{
    UserTypes::u2* result;

    result = new UserTypes::u2; // allocate memory
    result -> o ((CORBA::Octet) 3);

    return result;
}

void
UserTypeTester_impl::s1_in_t(const UserTypes::s1&)
    throw(CORBA::SystemException)
{
}

void
UserTypeTester_impl::s1_out_t(UserTypes::s1_out s)
    throw(CORBA::SystemException)
{
    s.s = (CORBA::Short) 19;
}

void
UserTypeTester_impl::s1_inout_t(UserTypes::s1& s)
    throw(CORBA::SystemException)
{
    s.s = (CORBA::Short) 77;
}

UserTypes::s1
UserTypeTester_impl::s1_ret_t()
    throw(CORBA::SystemException)
{
    UserTypes::s1 result;

    result.s = (CORBA::Short) 4;

    return result;
}

void
UserTypeTester_impl::s2_in_t(const UserTypes::s2&)
    throw(CORBA::SystemException)
{
}

void
UserTypeTester_impl::s2_out_t(UserTypes::s2_out s)
    throw(CORBA::SystemException)
{
    s = new UserTypes::s2; // allocate memory
    s -> s = (CORBA::Short) 4;
    s -> l = (CORBA::Long) 234235;
#ifdef HAVE_VCPLUSPLUS_BUGS
    s -> ll = (CORBA::LongLong) 2304020023040L;
#else
    s -> ll = (CORBA::LongLong) 2304020023040LL;
#endif
    s -> us = (CORBA::UShort) 443;
    s -> ul = (CORBA::ULong) 8;
    s -> f = (CORBA::Float) 4434.87;
    s -> d = (CORBA::Double) 187.7;
    s -> c = (CORBA::Char) 'h';
    s -> wc = (CORBA::WChar) '(';
    s -> st = CORBA::string_dup("Hi, Mom!");
    s -> ws = CORBA::wstring_dup(L"Dad too!");
    s -> b = (CORBA::Boolean) false;
    s -> o = (CORBA::Octet) 7;
    s -> a <<= CORBA::string_dup("I'm going in an any...");
}

void
UserTypeTester_impl::s2_inout_t(UserTypes::s2& s)
    throw(CORBA::SystemException)
{
    s.s = (CORBA::Short) 234;
    s.l = (CORBA::Long) 723456235;
#ifdef HAVE_VCPLUSPLUS_BUGS
    s.ll = (CORBA::LongLong) 2303454020023040L;
#else
    s.ll = (CORBA::LongLong) 2303454020023040LL;
#endif
    s.us = (CORBA::UShort) 43343;
    s.ul = (CORBA::ULong) 338;
    s.f = (CORBA::Float) 45434.857;
    s.d = (CORBA::Double) 1857.37;
    s.c = (CORBA::Char) 'q';
    s.wc = (CORBA::WChar) 'b';
    s.st = CORBA::string_dup("Lemond");
    s.ws = CORBA::wstring_dup(L"Steve Rex Cycles");
    s.b = (CORBA::Boolean) false;
    s.o = (CORBA::Octet) 7;
    s.a <<= CORBA::string_dup("Erin go bragh!");
}

UserTypes::s2*
UserTypeTester_impl::s2_ret_t()
    throw(CORBA::SystemException)
{
    UserTypes::s2* result;

    result = new UserTypes::s2; // allocate memory
    result -> s = (CORBA::Short) 4;
    result -> l = (CORBA::Long) 234235;
#ifdef HAVE_VCPLUSPLUS_BUGS
    result -> ll = (CORBA::LongLong) 2304020023040L;
#else
    result -> ll = (CORBA::LongLong) 2304020023040LL;
#endif
    result -> us = (CORBA::UShort) 443;
    result -> ul = (CORBA::ULong) 8;
    result -> f = (CORBA::Float) 4434.87;
    result -> d = (CORBA::Double) 187.7;
    result -> c = (CORBA::Char) 'h';
    result -> wc = (CORBA::WChar) '(';
    result -> st = CORBA::string_dup("Hi, Mom!");
    result -> ws = CORBA::wstring_dup(L"Dad too!");
    result -> b = (CORBA::Boolean) false;
    result -> o = (CORBA::Octet) 7;
    result -> a <<= CORBA::string_dup("I'm going in an any...");

    return result;
}

void
UserTypeTester_impl::interface_in_t(UserTypes::I_ptr)
    throw(CORBA::SystemException)
{
}

void
UserTypeTester_impl::interface_out_t(UserTypes::I_out interf)
    throw(CORBA::SystemException)
{
    interf = UserTypes::I::_nil();
}

void
UserTypeTester_impl::interface_inout_t(UserTypes::I_ptr& interf)
    throw(CORBA::SystemException)
{
    interf = UserTypes::I::_nil();
}

UserTypes::I_ptr
UserTypeTester_impl::interface_ret_t()
    throw(CORBA::SystemException)
{
    UserTypes::I_ptr result;

    result = UserTypes::I::_nil();

    return result;
}
