// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef BROADCASTER_IMPL_H
#define BROADCASTER_IMPL_H

#include <BroadcasterAdmin_impl.h>

namespace chat 
{

class Broadcaster_impl : public POA_chat::Broadcaster,
			 public PortableServer::RefCountServantBase
{
    //
    // The administrative object
    //
    BroadcasterAdmin_impl* admin_;

    //
    // Internal administrative identifier
    //
    CORBA::ULong id_;

    //
    // The POA
    //
    PortableServer::POA_var poa_;

public:

    //
    // Construction/Destruction
    //
    Broadcaster_impl(BroadcasterAdmin_impl* admin, 
		     CORBA::ULong id,
		     PortableServer::POA_ptr poa);
    ~Broadcaster_impl();

    PortableServer::POA_ptr _default_POA();

    //
    // Operations from the .idl file
    //

    virtual void say(const char*)
	throw(CORBA::SystemException);

    virtual void setNickName(const char* nick)
        throw(NickExists, CORBA::SystemException);

    virtual void getReceiverByNick(const char*, ReceiverDesc_out)
        throw(UnknownNick, CORBA::SystemException);

    virtual StringSeq* getReceiverNames()
        throw(CORBA::SystemException);

    virtual void unsubscribe()
        throw(CORBA::SystemException);

}; // class Broadcaster


} // namespace chat

#endif
