// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <Pizzeria_impl.h>

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

// ----------------------------------------------------------------------
// Pizzeria_impl constructor and destructor
// ----------------------------------------------------------------------

//
// IDL:Pizzeria:1.0
//
Pizzeria_impl::Pizzeria_impl()
{
}

Pizzeria_impl::~Pizzeria_impl()
{
}

// ----------------------------------------------------------------------
// Pizzeria_impl public member implementation
// ----------------------------------------------------------------------

//
// IDL:Pizzeria/order_pizza:1.0
//
void
Pizzeria_impl::order_pizza(Pizzeria::Size sz,
                           const Pizzeria::Toppings& t,
                           Customer* cust)
    throw(CORBA::SystemException)
{
    cout << "Pizza Order:" << endl;
    cout << endl;
    cout << "  Size    : ";
    switch(sz)
    {
    case Pizzeria::SMALL:
        cout << "Small" << endl;
        break;

    case Pizzeria::MEDIUM:
        cout << "Medium" << endl;
        break;

    case Pizzeria::LARGE:
        cout << "Large" << endl;
        break;
    }

    cout << "  Toppings: ";
    for(CORBA::ULong i = 0 ; i < t.length() ; i++)
    {
        switch(t[i])
        {
        case Pizzeria::CHEESE:
            cout << "Cheese ";
            break;
            
        case Pizzeria::ANCHOVIES:
            cout << "Anchovies ";
            break;
            
        case Pizzeria::SALAMI:
            cout << "Salami ";
            break;
            
        case Pizzeria::PEPPERONI:
            cout << "Pepperoni ";
            break;
        }
    }
    cout << endl;

    cout << "  Payment : ";
    cout << cust -> name() << ", CC# " << cust -> credit_card() << ", Exp "
         << cust -> expires() << endl;

    cout << endl;
}
