// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <Echo_impl.h>

// ----------------------------------------------------------------------
// Echo_impl constructor
// ----------------------------------------------------------------------

Echo_impl::Echo_impl(CORBA::ORB_ptr orb,
                       PortableServer::POA_ptr poa)
    : orb_(CORBA::ORB::_duplicate(orb)),
      poa_(PortableServer::POA::_duplicate(poa))
{
}

// ----------------------------------------------------------------------
// Echo_impl public member implementation
// ----------------------------------------------------------------------

wchar_t *
Echo_impl::echo_message(const wchar_t* msg)
    throw(CORBA::SystemException)
{
    CORBA::WString_var message = CORBA::wstring_dup(L"Echo: ");
    message += msg;
    
    //
    // Work-around for missing wcout.
    // This should be: 'wcout << message << endl;'
    //
    for(CORBA::ULong i = 0 ; i < OB::wcslen(message) ; i++)
	printf("%c", (char)message[i]);
    printf("\n");

    return message._retn();
}

PortableServer::POA_ptr
Echo_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(poa_);
}
