// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef ACTIVE_STATE_FACTORY_H
#define ACTIVE_STATE_FACTORY_H

#include <OB/IMR_skel.h>

#include <IMRLogger_fwd.h>

namespace IMR
{

//
// Forward declarations
//
class OADDatabase;
class InternalServer_impl;
class ServerDatabase;
class ServerStarter;

class ActiveStateFactory
{
    ServerDatabase* db_;
    PortableServer::POA_var activeStatePOA_;
    InternalServer_impl* server_;

    ActiveState_ptr createActiveStateReference(CORBA::Long);

public:

    ActiveStateFactory(ServerDatabase*,
                       OADDatabase*,
                       CORBA::ORB_ptr,
                       PortableServer::POA_ptr,
                       PortableServer::POA_ptr,
		       IMROAD::Logger_ptr,
		       ServerStarter*);
    ~ActiveStateFactory();

    ActiveState_ptr get_active_state(const char* server)
	throw(NoSuchServer, CORBA::SystemException);
};

}; // End namespace IMR

#endif
