// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_DATABASE_UPGRADE_H
#define OB_DATABASE_UPGRADE_H

namespace OB
{

class DatabaseUpgrade
{
    //
    // CRC Checksum calculation routine
    //
    unsigned short calcCrc(CORBA::Octet*, CORBA::ULong);

    //
    // Methods to write current version
    //
    bool writeHeader(FILE*, CORBA::ULong, CORBA::ULong);
    bool writeRecord(FILE*, CORBA::ULong, CORBA::ULong, CORBA::OctetSeq&);

    //
    // Upgrade from version 0
    //
    bool upgradeVersion0(FILE*, FILE*, CORBA::ULong, CORBA::ULong);

public:

    bool upgrade(const char*, const char*);
};

} // End namespace OB

#endif
