// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef IMR_SERVER_H
#define IMR_SERVER_H

namespace IMR
{

class OADEndpointManager_impl;
class ServerObserver_impl;
class InternalDomain_impl;
class OADDatabase;
class ServerDatabase;
class LocationForwarder;
class ServerStarter;

class IMRServer
{
    PortableServer::POA_var rootPOA_;
    PortableServer::POA_var fwdPOA_;
    PortableServer::POA_var adminPOA_;
    PortableServer::POAManager_var fwdManager_;

    PortableServer::ObjectId_var forwarderId_;

    LocationForwarder* forwarder_;

    ServerDatabase* serverdb_;
    OADDatabase* oaddb_;

    IMR::InternalDomain_impl* domainImpl_;
    IMR::OADEndpointManager_impl* endpointManager_;
    IMR::ServerObserver_impl* observerImpl_;

    JTCHandleT<ServerStarter> serverStarter_;

public:

    IMRServer(CORBA::ORB_ptr, IMROAD::Logger_ptr, OB::Properties_ptr, 
    	      const char*, bool);
    ~IMRServer();

    void connectOADs(bool);
    void startServerStarter();
};

} // End namespace IMR

#endif
