# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\imr$(LIBSUFFIX).lib
PDB_NAME        = $(top_srcdir)\lib\imr$(LIBSUFFIX).pdb
IMR_NAME	= $(top_srcdir)\bin\imr.exe
IMRADMIN_NAME   = $(top_srcdir)\bin\imradmin.exe
UPGRADE_NAME    = $(top_srcdir)\bin\imrdbupgrade.exe
MKREF_NAME	= $(top_srcdir)\bin\mkref.exe

UTILS		= $(IMR_NAME) \
		  $(IMRADMIN_NAME) \
		  $(MKREF_NAME) \
		  $(UPGRADE_NAME)

#
# Work around the inference rules problem with nmake.
#
!ifndef BUILD_UTILS

PDB_FLAGS       = /Fd$(PDB_NAME)
TARGETS		= $(LIB_NAME)

!else

TARGETS 	= $(UTILS)
PDB_FILES       = $(UTILS:.exe=.pdb) \
		  $(PDB_NAME)

!endif

!include $(top_srcdir)\config\Make.rules.mak

HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= IMR.obj \
		  IMR_skel.obj \
		  IMRState_skel.obj \
		  IMROAD.obj \
		  IMROAD_skel.obj \
		  OAD.obj \
		  OAD_skel.obj \
		  ProcessController_impl.obj \
		  ProcController.obj \
		  ProcObserver.obj \
		  ProcessEndpointManager_impl.obj \
		  IMRDB.obj \
		  IMRInternal.obj \
		  IMRInternal_skel.obj \
		  InternalDomain_impl.obj \
		  ActiveStateFactory.obj \
		  ServerFactory_impl.obj \
		  Server_impl.obj \
		  InternalServer_impl.obj \
		  OADEndpointManager_impl.obj \
		  ServerObserver_impl.obj \
		  ServerDatabase.obj \
		  ServerRecord.obj \
		  OADDatabase.obj \
		  LocationForwarder.obj \
		  IMRServer.obj \
		  ProcessDatabase.obj \
		  OADDB.obj \
		  OADServer.obj \
		  IMRLogger.obj \
		  IMRUtil.obj \
		  ServerStarter.obj \
		  Database.obj \
		  ObjectLocator.obj

IMR_OBJS	= IMRMain.obj

IMRADMIN_OBJS	= Admin.obj

UPGRADE_OBJS	= DBUpgrade.obj \
		  DatabaseUpgrade.obj

MKREF_OBJS	= Mkref.obj

SERVICE_NAME    = $(top_srcdir)\bin\ntimrservice.exe

SERVICE_OBJS =    NTIMRMain.obj \
                  NTIMRService.obj \
                  IMRMsg.res

DEF_NAME	= imr$(LIBSUFFIX).def
DLL_NAME	= $(top_srcdir)\lib\imr$(OB_LIBVER)$(LIBSUFFIX).dll
EXP_NAME	= $(top_srcdir)\lib\imr$(LIBSUFFIX).exp

!ifndef BUILD_UTILS
ALL_CPPFLAGS    = /DOB_IMR_IMPORT=/**/ /I. $(OB_CPPFLAGS) $(CPPFLAGS)
!else
ALL_CPPFLAGS    = /I. $(OB_CPPFLAGS) $(CPPFLAGS)
!endif

ALL_CXXFLAGS    = $(CXXFLAGS)
ALL_IDLFLAGS	= -I. --dll-import OB_IMR_IMPORT $(OB_IDLFLAGS)
ALL_LIBS        = $(LIB_NAME) $(OB_LIBS) $(LIBS)

!if "$(DLL)" == "yes"

ALL_DLLLIBS     = $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(LIB_NAME): $(DLL_NAME)

$(DEF_NAME):

$(DLL_NAME): $(LIB_OBJS) $(DEF_NAME)
        perl $(top_srcdir)\..\config\makedef.pl $(DEF_NAME) \
        imr$(OB_LIBVER)$(LIBSUFFIX) $(LIB_OBJS)
        $(LINK) $(LINKDLLFLAGS) /BASE:0x58000000 /def:$(DEF_NAME) \
        /IMPLIB:$(LIB_NAME) /out:$@ $(LIB_OBJS) $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS    = $(CXXFLAGS) $(PDB_FLAGS)

$(LIB_NAME): $(LIB_OBJS)
        $(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

!endif

$(IMR_NAME): $(IMR_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(IMR_OBJS) $(ALL_LIBS)

$(IMRADMIN_NAME): $(IMRADMIN_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(IMRADMIN_OBJS) $(ALL_LIBS)

$(UPGRADE_NAME): $(UPGRADE_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(UPGRADE_OBJS) $(ALL_LIBS)

$(MKREF_NAME): $(MKREF_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(MKREF_OBJS) $(ALL_LIBS)

$(SERVICE_NAME): $(SERVICE_OBJS) $(LIB_NAME)
        $(LINK) $(LINKFLAGS) /out:$@ $(SERVICE_OBJS) $(ALL_LIBS)

!ifdef BUILD_UTILS
all:: $(SERVICE_NAME)
!endif

clean::
        @if exist $(SERVICE_NAME) del $(SERVICE_NAME)
        @if exist $(SERVICE_NAME:.exe=.pdb) \
        del $(SERVICE_NAME:.exe=.pdb)

IMRMsg.rc : IMRMsg.mc
        mc IMRMsg.mc

IMRMsg.res: IMRMsg.rc
        rc -r -fo IMRMsg.res IMRMsg.rc

IMRMsg.h : IMRMsg.rc

IMR.cpp $(HDIR)/IMR.h $(HDIR)/IMR_skel.h: $(IDLDIR)/OB/IMR.idl
	-del IMR.cpp
	-del $(HDIR)\IMR.h
	-del IMR_skel.cpp
	-del $(HDIR)\IMR_skel.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB $(IDLDIR)/OB/IMR.idl
	move IMR.h $(HDIR)
	move IMR_skel.h $(HDIR)

IMRDB.cpp IMRDB.h: IMRDB.idl
	-del IMRDB.cpp IMRDB.h
	$(IDL) $(ALL_IDLFLAGS) --no-skeletons IMRDB.idl

IMROAD.cpp IMROAD.h: IMROAD.idl
	-del IMROAD.cpp IMROAD.h
	-del IMROAD_skel.cpp IMROAD_skel.h
	$(IDL) --fwd $(ALL_IDLFLAGS) IMROAD.idl

IMROAD_skel.cpp IMROAD_skel.h: IMROAD.cpp

IMRInternal.cpp IMRInternal.h: IMRInternal.idl
	-del IMRInternal.cpp IMRInternal.h
	-del IMRInternal_skel.cpp IMRInternal_skel.h
	$(IDL) $(ALL_IDLFLAGS) IMRInternal.idl

IMRInternal_skel.cpp IMRInternal_skel.h: IMRInternal.cpp

OAD.cpp OAD.h: OAD.idl
	-del OAD.cpp OAD.h
	-del OAD_skel.cpp OAD_skel.h
	$(IDL) --fwd $(ALL_IDLFLAGS) OAD.idl

OAD_skel.cpp OAD_skel.h: OAD.cpp

OADDB.cpp OADDB.h: OADDB.idl
	-del OADDB.cpp OADDB.h
	$(IDL) $(ALL_IDLFLAGS) --no-skeletons OADDB.idl

OADTypes.cpp OADTypes.h: OADTypes.idl
	-del OADTypes.cpp OADTypes.h
	-del OADTypes_skel.cpp OADTypes_skel.h
	$(IDL) $(ALL_IDLFLAGS) OADTypes.idl

!ifndef BUILD_UTILS

install:: all

min:: all

install_min:: all

$(EVERYTHING)::
	$(MAKE) /f Makefile.mak BUILD_UTILS=1 $@

!else

install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
	copy $(IMR_NAME) $(bindir)
	copy $(IMRADMIN_NAME) $(bindir)
	copy $(UPGRADE_NAME) $(bindir)
	copy $(MKREF_NAME) $(bindir)
        copy $(SERVICE_NAME) $(bindir)

!if "$(DLL)" == "yes"

DLL_PDB = $(DLL_NAME:.dll=.pdb)

install:: all
        copy $(DLL_NAME) $(libdir)
        copy $(EXP_NAME) $(libdir)
        if exist $(DLL_PDB) copy $(DLL_PDB) $(libdir)

!endif

clean::
        -del $(DLL_NAME) $(EXP_NAME) $(DEF_NAME) $(DLL_NAME:.dll=.pdb)

min:: all

install_min:: install

!endif


!include .windep
