// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef SERVER_RECORD_H
#define SERVER_RECORD_H

#include <IMRDB.h>
#include <ServerRecord_fwd.h>

namespace IMR
{

class ServerDatabase;
class ServerRecord : public OB::RefCount, public JTCMutex
{
    friend class ServerDatabase;

    //
    // Ther Server Database
    //
    ServerDatabase* db_;

    //
    // The Server Status Reord
    //
    IMRDB_4_1_0::ServerStatusRecord rec_;

    //
    // Has the server been destroyed?
    //
    bool destroyed_;

public:

    ServerRecord(ServerDatabase*, const IMRDB_4_1_0::ServerStatusRecord*);
    ~ServerRecord();

    static inline ServerRecord_ptr _duplicate(ServerRecord_ptr p)
    { if(p) p -> _OB_incRef(); return p; }
    static inline ServerRecord_ptr _nil()
    { return 0; }

    IMRDB_4_1_0::ServerStatusRecord& record();
};

} // End of namespace IMR

namespace CORBA
{

inline void
release(IMR::ServerRecord_ptr p)
{
    if(p)
        p -> _OB_decRef();
}

inline Boolean
is_nil(IMR::ServerRecord_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

#endif
