// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef SERVER_STARTER_H
#define SERVER_STARTER_H

#include <JTC/JTC.h>
#include <OB/list.h>

namespace IMR
{

class ActiveStateFactory;

class ServerStarter : public JTCThread, public JTCMonitor
{
    //
    // Stopped?
    //
    bool stopped_;

    //
    // Servers to spawn
    //
    OB_STL::list<CORBA::String_var> serverList_;

    //
    //
    //
    ActiveStateFactory* factory_;

public:

    ServerStarter();
    ~ServerStarter();

    virtual void run();

    void terminate();

    void add(const char*);

    void setActiveStateFactory(ActiveStateFactory*);
};

} // End of namespace IMR

#endif
