// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CoreTraceLevels.h>
#include <OB/Properties.h>
#include <OB/Object.h>
#include <OB/Any.h>
#include <OB/Logger.h>

using namespace CORBA;
using namespace OB;

// ----------------------------------------------------------------------
// External, non-inline duplicate/release for templates
// ----------------------------------------------------------------------

void
OBDuplicate(CoreTraceLevels_ptr p)
{
    if(p)
	p -> _OB_incRef();
}

void
OBRelease(CoreTraceLevels_ptr p)
{
    if(p)
	p -> _OB_decRef();
}

// ----------------------------------------------------------------------
// CoreTraceLevels constructor/destructor
// ----------------------------------------------------------------------

CoreTraceLevels::CoreTraceLevels(Logger_ptr logger,
				 Properties_ptr properties)
    : traceConnections_(0), 
      traceRetry_(0)
{
    Properties::KeySeq keys = properties -> getKeys("ooc.orb.trace.");

    ULong j;
    for(j = 0; j < keys.length(); ++j)
    {
        const char* key = keys[j];
        const char* value = properties -> getProperty(key);
        assert(value != 0);
	
	if(strcmp(key, "ooc.orb.trace.connections") == 0)
	{
	    traceConnections_ = atol(value);
	}
	else if(strcmp(key, "ooc.orb.trace.retry") == 0)
	{
	    traceRetry_ = atol(value);
	}
	else
	{
            String_var err = string_dup("ORB_init: unknown property: ");
            err += key;
            logger -> warning(err);
	}
    }
}

CoreTraceLevels::~CoreTraceLevels()
{
}

