// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/Any.h>
#include <OB/Upcall.h>
#include <OB/POAServantBase.h>
#include <OB/Object.h>
#include <OB/Logger.h>
#include <OB/OCI.h>
#include <OB/ORBInstance.h>

#include <DispatchRequest_impl.h>
#include <POA_impl.h>

using namespace CORBA;
using namespace OB;

// ----------------------------------------------------------------------
// DispatchRequest_impl constructor/destructor
// ----------------------------------------------------------------------

DispatchRequest_impl::DispatchRequest_impl(
    OBPortableServer::POA_impl* poa,
    const PortableServer::ObjectId& oid,
    Upcall_ptr upcall)
    : poaDummy_(PortableServer::POA::_duplicate(poa)),
      poa_(poa),
      oid_(oid),
      upcall_(Upcall::_duplicate(upcall)) // TODO: efficiency
{
}

DispatchRequest_impl::~DispatchRequest_impl()
{
}

// ----------------------------------------------------------------------
// DispatchRequest_impl public member implementation
// ----------------------------------------------------------------------

void
DispatchRequest_impl::invoke()
{
    poa_ -> _OB_dispatch(oid_, upcall_);

    upcall_ = Upcall::_nil();
}
