// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/Basic.h>
#include <OB/Template.h>
#include <OB/Hashtable.h>

using namespace CORBA;
using namespace OB;

ULong
StringHasher::hash(const char* key)
{
    ULong h = 0;
    ULong offset = 0;
    Long len = (Long)strlen(key);

    if(len < 16)
    {
        for(Long i = len ; i > 0 ; i--)
            h = (h * 37) + key[offset++];
    }
    else
    {
        Long skip = len / 8;
        for(Long i = len ; i > 0 ; i -= skip, offset += skip)
            h = (h * 39) + key[offset];
    }

    return h;
}

bool
StringHasher::comp(const char* k1, const char* k2)
{
    return strcmp(k1, k2) == 0;
}

ULong
StringSeqHasher::hash(const OB::StrSeq< int >& value)
{
    ULong result = 0;

    for(ULong i = 0 ; i < value.length() ; i++)
        result ^= StringHasher::hash(value[i]);

    return result;
}

bool
StringSeqHasher::comp(const OB::StrSeq< int >& v1, const OB::StrSeq< int >& v2)
{
    if(v1.length() == v2.length())
    {
        for(ULong i = 0 ; i < v1.length() ; i++)
        {
            if(strcmp(v1[i], v2[i]) != 0)
                return false;
        }

        return true;
    }

    return false;
}
