// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_ID_STRATEGY_H
#define OB_ID_STRATEGY_H

#include <OB/NativeTypes.h>
#include <OB/MarshalStubImpl.h>
#include <OB/POAInterface.h>

namespace OBPortableServer
{

//
// Forward declaration for POAPolicies
//
class POAPolicies;

//
// This abstract class represents an id generation strategy
//
class IdGenerationStrategy
{
public:

    virtual ~IdGenerationStrategy() { }

    //
    // Create a new ObjectId
    //
    virtual PortableServer::ObjectId* createId()
	throw(PortableServer::POA::WrongPolicy, CORBA::SystemException) = 0;

    //
    // Is an ObjectId valid?
    //
    virtual bool isValid(const PortableServer::ObjectId&)
	throw(CORBA::SystemException) = 0;
};

class IdGenerationStrategyFactory
{
public:

    static IdGenerationStrategy* createIdGenerationStrategy(
	OBPortableServer::POAPolicies*);
};

} // End of namespace OB

#endif
