// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/OCI_init.h>
#include <OB/Except.h>
#include <OB/list.h>

using namespace CORBA;
using namespace OB;

struct NameInitPair
{
    String_var name;
    OCI::INIT init;
};

static OB_STL::list<NameInitPair> init_;

// ----------------------------------------------------------------------
// Global functions
// ----------------------------------------------------------------------

void
OCI::register_plugin(const char* name, INIT init)
{
    for(OB_STL::list<NameInitPair>::iterator it = init_.begin() ;
        it != init_.end() ;
        it++)
    {
        if(strcmp(name, (*it).name) == 0)
            throw INITIALIZE("OCI plug-in already registered");
    }

    NameInitPair pair;
    pair.name = name;
    pair.init = init;
    init_.push_back(pair);
}

OCI::INIT
OCI::lookup_plugin(const char* name)
{
    for(OB_STL::list<NameInitPair>::iterator it = init_.begin() ;
        it != init_.end() ;
        it++)
    {
        if(strcmp(name, (*it).name) == 0)
            return (*it).init;
    }

    return 0;
}
