// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/ORBInstance.h>
#include <OB/Any.h>

#include <POAPolicies_impl.h>
#include <Dispatch_impl.h>

using namespace OB;
using namespace CORBA;

// ----------------------------------------------------------------------
// ThreadPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

PortableServer::ThreadPolicy_impl::ThreadPolicy_impl(ThreadPolicyValue value)
    : value_(value)
{
}

PortableServer::ThreadPolicy_impl::~ThreadPolicy_impl()
{
}

// ----------------------------------------------------------------------
// ThreadPolicy_impl public member implementation
// ----------------------------------------------------------------------

PortableServer::ThreadPolicyValue
PortableServer::ThreadPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
PortableServer::ThreadPolicy_impl::policy_type()
    throw(SystemException)
{
    return THREAD_POLICY_ID;
}

Policy_ptr
PortableServer::ThreadPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
PortableServer::ThreadPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// LifespanPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

PortableServer::LifespanPolicy_impl::LifespanPolicy_impl(
    LifespanPolicyValue value)
    : value_(value)
{
}

PortableServer::LifespanPolicy_impl::~LifespanPolicy_impl()
{
}

// ----------------------------------------------------------------------
// LifespanPolicy_impl public member implementation
// ----------------------------------------------------------------------

PortableServer::LifespanPolicyValue
PortableServer::LifespanPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
PortableServer::LifespanPolicy_impl::policy_type()
    throw(SystemException)
{
    return LIFESPAN_POLICY_ID;
}

Policy_ptr
PortableServer::LifespanPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
PortableServer::LifespanPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// IdUniquenessPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

PortableServer::IdUniquenessPolicy_impl::IdUniquenessPolicy_impl(
    IdUniquenessPolicyValue value)
    : value_(value)
{
}

PortableServer::IdUniquenessPolicy_impl::~IdUniquenessPolicy_impl()
{
}

// ----------------------------------------------------------------------
// IdUniquenessPolicy_impl public member implementation
// ----------------------------------------------------------------------

PortableServer::IdUniquenessPolicyValue
PortableServer::IdUniquenessPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
PortableServer::IdUniquenessPolicy_impl::policy_type()
    throw(SystemException)
{
    return ID_UNIQUENESS_POLICY_ID;
}

Policy_ptr
PortableServer::IdUniquenessPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
PortableServer::IdUniquenessPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// IdAssignmentPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

PortableServer::IdAssignmentPolicy_impl::IdAssignmentPolicy_impl(
    IdAssignmentPolicyValue value)
    : value_(value)
{
}

PortableServer::IdAssignmentPolicy_impl::~IdAssignmentPolicy_impl()
{
}

// ----------------------------------------------------------------------
// IdAssignmentPolicy_impl public member implementation
// ----------------------------------------------------------------------

PortableServer::IdAssignmentPolicyValue
PortableServer::IdAssignmentPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
PortableServer::IdAssignmentPolicy_impl::policy_type()
    throw(SystemException)
{
    return ID_ASSIGNMENT_POLICY_ID;
}

Policy_ptr
PortableServer::IdAssignmentPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
PortableServer::IdAssignmentPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// ImplicitActivationPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

PortableServer::ImplicitActivationPolicy_impl::ImplicitActivationPolicy_impl(
    ImplicitActivationPolicyValue value)
    : value_(value)
{
}

PortableServer::ImplicitActivationPolicy_impl::~ImplicitActivationPolicy_impl()
{
}

// ----------------------------------------------------------------------
// ImplicitActivationPolicy_impl public member implementation
// ----------------------------------------------------------------------

PortableServer::ImplicitActivationPolicyValue
PortableServer::ImplicitActivationPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
PortableServer::ImplicitActivationPolicy_impl::policy_type()
    throw(SystemException)
{
    return IMPLICIT_ACTIVATION_POLICY_ID;
}

Policy_ptr
PortableServer::ImplicitActivationPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
PortableServer::ImplicitActivationPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// ServantRetentionPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

PortableServer::ServantRetentionPolicy_impl::ServantRetentionPolicy_impl(
    ServantRetentionPolicyValue value)
    : value_(value)
{
}

PortableServer::ServantRetentionPolicy_impl::~ServantRetentionPolicy_impl()
{
}

// ----------------------------------------------------------------------
// ServantRetentionPolicy_impl public member implementation
// ----------------------------------------------------------------------

PortableServer::ServantRetentionPolicyValue
PortableServer::ServantRetentionPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
PortableServer::ServantRetentionPolicy_impl::policy_type()
    throw(SystemException)
{
    return SERVANT_RETENTION_POLICY_ID;
}

Policy_ptr
PortableServer::ServantRetentionPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
PortableServer::ServantRetentionPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// RequestProcessingPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

PortableServer::RequestProcessingPolicy_impl::RequestProcessingPolicy_impl(
    RequestProcessingPolicyValue value)
    : value_(value)
{
}

PortableServer::RequestProcessingPolicy_impl::~RequestProcessingPolicy_impl()
{
}

// ----------------------------------------------------------------------
// RequestProcessingPolicy_impl public member implementation
// ----------------------------------------------------------------------

PortableServer::RequestProcessingPolicyValue
PortableServer::RequestProcessingPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
PortableServer::RequestProcessingPolicy_impl::policy_type()
    throw(SystemException)
{
    return REQUEST_PROCESSING_POLICY_ID;
}

Policy_ptr
PortableServer::RequestProcessingPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
PortableServer::RequestProcessingPolicy_impl::destroy()
    throw(SystemException)
{
}

//
// ORBacus extensions
//

// ----------------------------------------------------------------------
// SynchronizationPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

OBPortableServer::SynchronizationPolicy_impl::SynchronizationPolicy_impl(
    SynchronizationPolicyValue value)
    : value_(value)
{
}

OBPortableServer::SynchronizationPolicy_impl::~SynchronizationPolicy_impl()
{
}

// ----------------------------------------------------------------------
// SynchronizationPolicy_impl public member implementation
// ----------------------------------------------------------------------

OBPortableServer::SynchronizationPolicyValue
OBPortableServer::SynchronizationPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
OBPortableServer::SynchronizationPolicy_impl::policy_type()
    throw(SystemException)
{
    return SYNCHRONIZATION_POLICY_ID;
}

Policy_ptr
OBPortableServer::SynchronizationPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
OBPortableServer::SynchronizationPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// DispatchStrategyPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

OBPortableServer::DispatchStrategyPolicy_impl::DispatchStrategyPolicy_impl(
    DispatchStrategy_ptr value)
    : value_(DispatchStrategy::_duplicate(value))
{
}

OBPortableServer::DispatchStrategyPolicy_impl::~DispatchStrategyPolicy_impl()
{
}

// ----------------------------------------------------------------------
// DispatchStrategyPolicy_impl public member implementation
// ----------------------------------------------------------------------

DispatchStrategy_ptr
OBPortableServer::DispatchStrategyPolicy_impl::value()
    throw(SystemException)
{
    return DispatchStrategy::_duplicate(value_);
}

PolicyType
OBPortableServer::DispatchStrategyPolicy_impl::policy_type()
    throw(SystemException)
{
    return DISPATCH_STRATEGY_POLICY_ID;
}

Policy_ptr
OBPortableServer::DispatchStrategyPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
OBPortableServer::DispatchStrategyPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// InterceptorCallPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

OBPortableServer::InterceptorCallPolicy_impl::InterceptorCallPolicy_impl(
    bool value)
    : value_(value)
{
}

OBPortableServer::InterceptorCallPolicy_impl::~InterceptorCallPolicy_impl()
{
}

// ----------------------------------------------------------------------
// InterceptorCallPolicy_impl public member implementation
// ----------------------------------------------------------------------

CORBA::Boolean
OBPortableServer::InterceptorCallPolicy_impl::value()
    throw(SystemException)
{
    return value_;
}

PolicyType
OBPortableServer::InterceptorCallPolicy_impl::policy_type()
    throw(SystemException)
{
    return INTERCEPTOR_CALL_POLICY_ID;
}

Policy_ptr
OBPortableServer::InterceptorCallPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
OBPortableServer::InterceptorCallPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// POAPolicies constructor and destructor
// ----------------------------------------------------------------------

OBPortableServer::POAPolicies::POAPolicies(ORBInstance_ptr orbInstance,
					   const PolicyList& policies)
{
    //
    // Set the default policy values
    //
    interceptorCallPolicyValue_ = true;
    synchronizationPolicyValue_ = NO_SYNCHRONIZATION;
    lifespanPolicyValue_ = PortableServer::TRANSIENT;
    idUniquenessPolicyValue_ = PortableServer::UNIQUE_ID;
    idAssignmentPolicyValue_ = PortableServer::SYSTEM_ID;
    implicitActivationPolicyValue_ = PortableServer::NO_IMPLICIT_ACTIVATION;
    servantRetentionPolicyValue_ = PortableServer::RETAIN;
    requestProcessingPolicyValue_ = PortableServer::USE_ACTIVE_OBJECT_MAP_ONLY;
    dispatchStrategyPolicyValue_ = DispatchStrategy::_nil();

    for(ULong i = 0; i < policies.length(); ++i)
    {
        PolicyType policyType = policies[i] -> policy_type();
        if(policyType == PortableServer::THREAD_POLICY_ID)
        {
            PortableServer::ThreadPolicy_var policy =
		PortableServer::ThreadPolicy::_narrow(policies[i]);
            synchronizationPolicyValue_ =
		(policy -> value() == PortableServer::ORB_CTRL_MODEL)
			? NO_SYNCHRONIZATION
			: SYNCHRONIZE_ON_ORB;
        }
        else if(policyType ==  PortableServer::LIFESPAN_POLICY_ID)
        {
            PortableServer::LifespanPolicy_var policy =
		PortableServer::LifespanPolicy::_narrow(policies[i]);
            lifespanPolicyValue_ = policy -> value();
        }
        else if(policyType == PortableServer::ID_UNIQUENESS_POLICY_ID)
        {
            PortableServer::IdUniquenessPolicy_var policy =
		PortableServer::IdUniquenessPolicy::_narrow(policies[i]);
            idUniquenessPolicyValue_ = policy -> value();
        }
        else if(policyType == PortableServer::ID_ASSIGNMENT_POLICY_ID)
        {
            PortableServer::IdAssignmentPolicy_var policy =
		PortableServer::IdAssignmentPolicy::_narrow(policies[i]);
            idAssignmentPolicyValue_ = policy -> value();
        }
        else if(policyType == PortableServer::IMPLICIT_ACTIVATION_POLICY_ID)
        {
            PortableServer::ImplicitActivationPolicy_var policy =
		PortableServer::ImplicitActivationPolicy::_narrow(policies[i]);
            implicitActivationPolicyValue_ = policy -> value();
        }
        else if(policyType == PortableServer::SERVANT_RETENTION_POLICY_ID)
        {
            PortableServer::ServantRetentionPolicy_var policy =
		PortableServer::ServantRetentionPolicy::_narrow(policies[i]);
            servantRetentionPolicyValue_ = policy -> value();
        }
        else if(policyType == PortableServer::REQUEST_PROCESSING_POLICY_ID)
        {
            PortableServer::RequestProcessingPolicy_var policy =
		PortableServer::RequestProcessingPolicy::_narrow(policies[i]);
            requestProcessingPolicyValue_ = policy -> value();
        }
        //
        // ORBacus proprietary policies
        //
        else if(policyType == SYNCHRONIZATION_POLICY_ID)
        {
            SynchronizationPolicy_var policy =
		SynchronizationPolicy::_narrow(policies[i]);
            synchronizationPolicyValue_ = policy -> value();
        }
        else if(policyType == DISPATCH_STRATEGY_POLICY_ID)
        {
            DispatchStrategyPolicy_var policy =
		DispatchStrategyPolicy::_narrow(policies[i]);
            dispatchStrategyPolicyValue_ = policy -> value();
        }
        else if(policyType == INTERCEPTOR_CALL_POLICY_ID)
        {
            InterceptorCallPolicy_var policy =
		InterceptorCallPolicy::_narrow(policies[i]);
            interceptorCallPolicyValue_ = policy -> value();
        }
	//
	// Otherwise the policy is not a ORB defined POA policy
	//
    }

    if(is_nil(dispatchStrategyPolicyValue_))
    {
	DispatchStrategyFactory_var dsf =
	    orbInstance -> getDispatchStrategyFactory();
	dispatchStrategyPolicyValue_ =
	    dsf -> create_default_dispatch_strategy();	
    }
}

bool
OBPortableServer::POAPolicies::interceptorCallPolicy() const
{
    return interceptorCallPolicyValue_;
}

OBPortableServer::SynchronizationPolicyValue
OBPortableServer::POAPolicies::synchronizationPolicy() const
{
#ifdef never
    //
    // If the server concurrency model is Threaded then we always
    // return SYNCHRONIZE_ON_ORB
    //
    //
    // TODO: Fix this!
    //
    if(ORB_impl::server_conc_model() ==
           ORB_impl::ServerConcModelThreaded)
	return SYNCHRONIZE_ON_ORB;
#endif // never
    return synchronizationPolicyValue_;
}

OB::DispatchStrategy_ptr
OBPortableServer::POAPolicies::dispatchStrategyPolicy() const
{
    return DispatchStrategy::_duplicate(dispatchStrategyPolicyValue_);
}

PortableServer::LifespanPolicyValue
OBPortableServer::POAPolicies::lifespanPolicy() const
{
    return lifespanPolicyValue_;
}

PortableServer::IdUniquenessPolicyValue
OBPortableServer::POAPolicies::idUniquenessPolicy() const
{
    return idUniquenessPolicyValue_;
}

PortableServer::IdAssignmentPolicyValue
OBPortableServer::POAPolicies::idAssignmentPolicy() const
{
    return idAssignmentPolicyValue_;
}

PortableServer::ImplicitActivationPolicyValue
OBPortableServer::POAPolicies::implicitActivationPolicy() const
{
    return implicitActivationPolicyValue_;
}

PortableServer::ServantRetentionPolicyValue
OBPortableServer::POAPolicies::servantRetentionPolicy() const
{
    return servantRetentionPolicyValue_;
}

PortableServer::RequestProcessingPolicyValue
OBPortableServer::POAPolicies::requestProcessingPolicy() const
{
    return requestProcessingPolicyValue_;
}

PolicyList*
OBPortableServer::POAPolicies::recreate() const
{
    //
    // TODO:
    //
    // No ThreadPolicy policy appended. The problem is that some
    // values of SyncPolicy don't map. I guess the real solution to
    // this is to only create those policies that were provided. Also,
    // providing both Sync policy and ThreadPolicy should be invalid.
    //
    
    PolicyList_var pl = new PolicyList;

    CORBA::ULong plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
        new PortableServer::LifespanPolicy_impl(lifespanPolicyValue_);

    plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
        new PortableServer::IdUniquenessPolicy_impl(idUniquenessPolicyValue_);

    plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
        new PortableServer::IdAssignmentPolicy_impl(idAssignmentPolicyValue_);

    plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
        new PortableServer::ImplicitActivationPolicy_impl(
            implicitActivationPolicyValue_);

    plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
        new PortableServer::ServantRetentionPolicy_impl(
            servantRetentionPolicyValue_);

    plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
        new PortableServer::RequestProcessingPolicy_impl(
            requestProcessingPolicyValue_);

    plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
        new SynchronizationPolicy_impl(synchronizationPolicyValue_);

    plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
        new DispatchStrategyPolicy_impl(dispatchStrategyPolicyValue_);

    plLength  = pl -> length();
    pl -> length(plLength + 1);
    pl[plLength] =
      new InterceptorCallPolicy_impl(interceptorCallPolicyValue_);

    return pl._retn();
}

// ----------------------------------------------------------------------
// POAPolicyFactory_impl public member implementation
// ----------------------------------------------------------------------

Policy_ptr
PortableInterceptor::POAPolicyFactory_impl::create_policy(
    PolicyType type,
    const Any& val)
    throw(PolicyError)
{
    if(type == PortableServer::THREAD_POLICY_ID)
    {
        PortableServer::ThreadPolicyValue v;
        if(val >>= v)
            return new PortableServer::ThreadPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

    if(type == PortableServer::LIFESPAN_POLICY_ID)
    {
        PortableServer::LifespanPolicyValue v;
        if(val >>= v)
            return new PortableServer::LifespanPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

    if(type == PortableServer::ID_UNIQUENESS_POLICY_ID)
    {
        PortableServer::IdUniquenessPolicyValue v;
        if(val >>= v)
            return new PortableServer::IdUniquenessPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

    if(type == PortableServer::ID_ASSIGNMENT_POLICY_ID)
    {
        PortableServer::IdAssignmentPolicyValue v;
        if(val >>= v)
            return new PortableServer::IdAssignmentPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

    if(type == PortableServer::IMPLICIT_ACTIVATION_POLICY_ID)
    {
        PortableServer::ImplicitActivationPolicyValue v;
        if(val >>= v)
            return new PortableServer::ImplicitActivationPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

    if(type == PortableServer::SERVANT_RETENTION_POLICY_ID)
    {
        PortableServer::ServantRetentionPolicyValue v;
        if(val >>= v)
            return new PortableServer::ServantRetentionPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

    if(type == PortableServer::REQUEST_PROCESSING_POLICY_ID)
    {
        PortableServer::RequestProcessingPolicyValue v;
        if(val >>= v)
            return new PortableServer::RequestProcessingPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

    if(type == OBPortableServer::SYNCHRONIZATION_POLICY_ID)
    {
        OBPortableServer::SynchronizationPolicyValue v;
        if(val >>= v)
            return new OBPortableServer::SynchronizationPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

    if(type == OBPortableServer::INTERCEPTOR_CALL_POLICY_ID)
    {
	CORBA::Boolean v;
        if(val >>= Any::to_boolean(v))
            return new OBPortableServer::InterceptorCallPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }

/*
 * We can't implement this yet since locality constrained objects cannot
 * be placed in Any yet
 *
    if(type == DISPATCH_STRATEGY_POLICY_ID)
    {
        DispatchStrategy_ptr v;
        if(val >>= v)
            return new DispatchStrategyPolicy_impl(v);
        throw PolicyError(BAD_POLICY_TYPE);
    }
*/
    throw PolicyError(BAD_POLICY);
    return Policy::_nil(); // Some compilers need this
}
