typedef union
{
    //
    // General types
    //
    char* string;
    wchar_t* wstring;
    CORBA::StringSeq* stringSeq;
    OB_STL::list<CORBA::String_var>* stringList;

    CORBA::Long longVal;
    CORBA::ULong uLongVal;
    CORBA::ULongLong uLongLongVal;
    CORBA::Char charVal;
    CORBA::WChar wcharVal;
    CORBA::Double doubleVal;
    CORBA::Boolean booleanVal;
    CORBA::Fixed* fixedVal;

    CORBA::Any* any;
    CORBA::AnySeq* anySeq;
    OB_STL::list<CORBA::Any_var>* anyList;

    //
    // Special types
    //
    IdlDeclarator* declarator;
    OB_STL::list<IdlDeclarator_var>* declaratorList;
    IdlValueInfo* valueInfo;

    //
    // Types from the IR
    //
    CORBA::IDLType_ptr idlType;
    CORBA::ExceptionDef_ptr exceptionDef;
    CORBA::AttributeMode attributeMode;
    CORBA::DefinitionKind definitionKind;
    CORBA::StructDef_ptr structDef;
    CORBA::StructMember* structMember;
    OB_STL::list<CORBA::StructMember_var>* structMemberList;
    CORBA::UnionDef_ptr unionDef;
    OB_STL::list<CORBA::UnionMember>* unionMemberList;
    CORBA::UnionMember* unionMember;
    CORBA::EnumDef_ptr enumDef;
    OB_STL::list<CORBA::String_var>* enumMemberList;
    CORBA::InterfaceDef_ptr interfaceDef;
    OB_STL::list<CORBA::InterfaceDef_var>* interfaceDefList;
    CORBA::OperationMode operationMode;
    CORBA::ParameterMode parameterMode;
    CORBA::ParameterDescription* parameterDescription;
    OB_STL::list<CORBA::ParameterDescription_var>* parDescriptionList;
    OB_STL::list<CORBA::ExceptionDef_var>* exceptionDefList;
    OB_STL::list<CORBA::ContextIdentifier_var>* contextIdList;
    CORBA::Visibility memberVisibility;
    CORBA::Initializer* initializer;
} YYSTYPE;
#define	IDL_ABSTRACT	257
#define	IDL_ANY	258
#define	IDL_ATTRIBUTE	259
#define	IDL_BOOLEAN	260
#define	IDL_CASE	261
#define	IDL_CHAR	262
#define	IDL_CONST	263
#define	IDL_CONTEXT	264
#define	IDL_CUSTOM	265
#define	IDL_DEFAULT	266
#define	IDL_DOUBLE	267
#define	IDL_ENUM	268
#define	IDL_EXCEPTION	269
#define	IDL_FACTORY	270
#define	IDL_FIXED	271
#define	IDL_FLOAT	272
#define	IDL_IN	273
#define	IDL_INOUT	274
#define	IDL_INTERFACE	275
#define	IDL_LOCAL	276
#define	IDL_LONG	277
#define	IDL_MODULE	278
#define	IDL_NATIVE	279
#define	IDL_OBJECT	280
#define	IDL_OCTET	281
#define	IDL_ONEWAY	282
#define	IDL_OUT	283
#define	IDL_PRIVATE	284
#define	IDL_PUBLIC	285
#define	IDL_RAISES	286
#define	IDL_READONLY	287
#define	IDL_SEQUENCE	288
#define	IDL_SHORT	289
#define	IDL_STRING	290
#define	IDL_STRUCT	291
#define	IDL_SUPPORTS	292
#define	IDL_SWITCH	293
#define	IDL_TRUNCATABLE	294
#define	IDL_TYPEDEF	295
#define	IDL_UNSIGNED	296
#define	IDL_UNION	297
#define	IDL_VALUEBASE	298
#define	IDL_VALUETYPE	299
#define	IDL_VOID	300
#define	IDL_WCHAR	301
#define	IDL_WSTRING	302
#define	IDL_LEFT_SHIFT	303
#define	IDL_RIGHT_SHIFT	304
#define	IDL_SCOPE_DELIMITOR	305
#define	IDL_IDENTIFIER	306
#define	IDL_INTEGER_LITERAL	307
#define	IDL_STRING_LITERAL	308
#define	IDL_WIDE_STRING_LITERAL	309
#define	IDL_CHARACTER_LITERAL	310
#define	IDL_WIDE_CHARACTER_LITERAL	311
#define	IDL_FLOATING_PT_LITERAL	312
#define	IDL_FIXED_PT_LITERAL	313
#define	IDL_FALSE	314
#define	IDL_TRUE	315


extern YYSTYPE yylval;
