# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\obtestins$(LIBSUFFIX).lib
PDB_NAME	= $(top_srcdir)\lib\obtestins$(LIBSUFFIX).pdb

SERVER_NAME	= server.exe
CLIENT_NAME	= client.exe

!ifndef BUILD_EXE
TARGETS		= $(LIB_NAME)
PDB_FLAGS	= /Fd$(PDB_NAME)
!else
TARGETS 	= $(SERVER_NAME) \
		  $(CLIENT_NAME)

PDB_FILES       = $(TARGETS:.exe=.pdb) \
		  $(PDB_NAME)
!endif

!include $(top_srcdir)\config\Make.rules.mak

LIB_OBJS	= URLTest.obj \
		  URLTest_skel.obj \
                  URLTest_impl.obj

SERVER_OBJS	= Server.obj

CLIENT_OBJS	= Client.obj

GENERATED	= URLTest.cpp \
		  URLTest.h \
		  URLTest_skel.cpp \
		  URLTest_skel.h

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)
ALL_CPPFLAGS	= /I. /I..\include $(OB_CPPFLAGS) $(CPPFLAGS)
IDL_FLAGS	= -I$(IDLDIR)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	-del $@
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERVER_NAME): $(SERVER_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(SERVER_OBJS) $(ALL_LIBS)

$(CLIENT_NAME): $(CLIENT_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(CLIENT_OBJS) $(ALL_LIBS)

URLTest.cpp URLTest.h: URLTest.idl
	-del URLTest.cpp URLTest.h
	-del URLTest_skel.cpp URLTest_skel.h
	$(IDL) $(IDL_FLAGS) URLTest.idl

URLTest_skel.cpp URLTest_skel.h: URLTest.cpp

!ifndef BUILD_EXE
install:: all

$(EVERYTHING)::
	$(MAKE) /f Makefile.mak BUILD_EXE=1 $@
!else
install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
!endif


!include .windep
