// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <Test_impl.h>

Test_impl::Test_impl(CORBA::ORB_ptr orb,
		     PortableServer::POA_ptr poa)
    : orb_(CORBA::ORB::_duplicate(orb)),
      poa_(PortableServer::POA::_duplicate(poa)),
      localTest_(new LocalTest_impl)
{
}

Test_impl::~Test_impl()
{
}

PortableServer::POA_ptr
Test_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(poa_);
}

void
Test_impl::say(const char* /* s */)
    throw(CORBA::SystemException)
{
    //OB_INFO_LN(s);
}

void
Test_impl::intest(Test_ptr t)
    throw(CORBA::SystemException)
{
    t -> say("hi");
}

void
Test_impl::inany(const CORBA::Any& a)
    throw(CORBA::SystemException)
{
    Test_ptr t;
    assert(a >>= t);
}

void
Test_impl::outany(CORBA::Any_out a)
    throw(CORBA::SystemException)
{
    CORBA::Any r;
    r <<= localTest_;
    a = new CORBA::Any(r);
}

Test_ptr
Test_impl::returntest()
    throw(CORBA::SystemException)
{
    return Test::_duplicate(localTest_);
}

void
Test_impl::shutdown()
    throw(CORBA::SystemException)
{
    orb_ -> shutdown(false);
}

LocalTest_impl::LocalTest_impl()
{
}

LocalTest_impl::~LocalTest_impl()
{
}

void
LocalTest_impl::say(const char* /* s */)
    throw(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT();
}

void
LocalTest_impl::intest(Test_ptr /* t */)
    throw(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT();
}

void
LocalTest_impl::inany(const CORBA::Any& /* a */)
    throw(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT();
}

void
LocalTest_impl::outany(CORBA::Any_out)
    throw(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT();
}

Test_ptr
LocalTest_impl::returntest()
    throw(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT();
    return Test::_nil(); // Some compilers need this

}

void
LocalTest_impl::shutdown()
    throw(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT();

}
