// **********************************************************************
//
// Copyright (c) 2001
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/Properties.h>
#include <OB/Logger.h>

#include <stdlib.h>

using namespace CORBA;

int
main(
    int argc,
    char* argv[],
    char*[]
)
{
    int status = EXIT_SUCCESS;
    ORB_var orb;

    try
    {
	OB::Reactor_var reactor;
	int ReactorInit(int, char*[], OB::Reactor_out);
	status = ReactorInit(argc, argv, reactor);

	if (status == EXIT_SUCCESS)
	{
	    orb = OBCORBA::ORB_init(argc, argv, OB::Properties::_nil(),
				    OB::Logger::_nil(), reactor);
	    
	    int ClientRun(ORB_ptr, bool, int, char*[]);
	    status = ClientRun(orb, false, argc, argv);
	}
    }
    catch (const Exception& ex)
    {
	OB_ERROR(ex);
	status = EXIT_FAILURE;
    }

    if (!is_nil(orb))
    {
	try
	{
	    orb->destroy();
	}
	catch (const Exception& ex)
	{
	    OB_ERROR(ex);
	    status = EXIT_FAILURE;
	}
    }

    return status;
}
