# **********************************************************************
#
# Copyright (c) 2001
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

#
# REVISIT rename library libOBTestMain. Temporarily called libOBTestNewMain
#

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\obtestnewmain$(LIBSUFFIX).lib
PDB_NAME        = $(top_srcdir)\lib\obtestnewmain$(LIBSUFFIX).pdb
SERVER_NAME	= server.exe
CLIENT_NAME	= client.exe
COLLOCATED_NAME	= collocated.exe

!ifndef BUILD_EXE
TARGETS		= $(LIB_NAME) 
PDB_FLAGS       = /Fd$(PDB_NAME)
!else
TARGETS 	= $(SERVER_NAME) \
		  $(CLIENT_NAME) \
		  $(COLLOCATED_NAME)

PDB_FILES	= $(TARGETS:.exe=.pdb) \
	          $(PDB_NAME)
!endif

!include $(top_srcdir)\config\Make.rules.mak

LIB_OBJS	= TestIntf.obj \
		  TestIntf_skel.obj \
		  TestIntfBasic.obj \
		  TestIntfBasic_skel.obj \
		  TestIntfContext.obj \
		  TestIntfContext_skel.obj \
		  TestIntfExceptions.obj \
		  TestIntfExceptions_skel.obj \
		  TestIntfExceptionsExt_2_0.obj \
		  TestIntfExceptionsExt_2_0_skel.obj \
		  TestIntfWChar.obj \
		  TestIntfWChar_skel.obj \
		  TestIntfFixed.obj \
		  TestIntfFixed_skel.obj \
		  TestIntfLongDouble.obj \
		  TestIntfLongDouble_skel.obj \
		  TestIntfLongLong.obj \
		  TestIntfLongLong_skel.obj \
		  TestIntfExceptionsExt_2_3.obj \
		  TestIntfExceptionsExt_2_3_skel.obj \
		  TestIntfStubTimeout.obj \
		  TestIntfStubTimeout_skel.obj \
		  TestIntf_impl.obj \
		  TestIntfBasic_impl.obj \
		  TestIntfContext_impl.obj \
		  TestIntfExceptions_impl.obj \
		  TestIntfExceptionsExt_2_0_impl.obj \
		  TestIntfWChar_impl.obj \
		  TestIntfFixed_impl.obj \
		  TestIntfLongDouble_impl.obj \
		  TestIntfLongLong_impl.obj \
		  TestIntfExceptionsExt_2_3_impl.obj \
		  TestIntfStubTimeout_impl.obj \
		  TestIntfBasicDSI_impl.obj \
		  TestIntfContextDSI_impl.obj \
		  TestIntfExceptionsDSI_impl.obj \
		  TestIntfExceptionsExt_2_0DSI_impl.obj \
		  TestIntfWCharDSI_impl.obj \
		  TestIntfFixedDSI_impl.obj \
		  TestIntfLongDoubleDSI_impl.obj \
		  TestIntfLongLongDSI_impl.obj \
		  TestIntfExceptionsExt_2_3DSI_impl.obj \
		  TestIntfStubTimeoutDSI_impl.obj \
		  TestObject.obj \
		  TestObjectBasic.obj \
		  TestObjectContext.obj \
		  TestObjectExceptions.obj \
		  TestObjectExceptionsExt_2_0.obj \
		  TestObjectWChar.obj \
		  TestObjectFixed.obj \
		  TestObjectLongDouble.obj \
		  TestObjectLongLong.obj \
		  TestObjectExceptionsExt_2_3.obj \
		  TestObjectStubTimeout.obj \
		  ReactorInit.obj \
		  Server.obj \
		  Client.obj

SERVER_OBJS	= ServerMain.obj

CLIENT_OBJS	= ClientMain.obj

COLLOCATED_OBJS	= CollocatedMain.obj

GENERATED	= TestIntf.cpp \
		  TestIntf.h \
		  TestIntf_skel.cpp \
		  TestIntf_skel.h \
		  TestIntf_skel_tie.h \
		  TestIntfBasic.cpp \
		  TestIntfBasic.h \
		  TestIntfBasic_skel.cpp \
		  TestIntfBasic_skel.h \
		  TestIntfBasic_skel_tie.h \
		  TestIntfContext.cpp \
		  TestIntfContext.h \
		  TestIntfContext_skel.cpp \
		  TestIntfContext_skel.h \
		  TestIntfContext_skel_tie.h \
		  TestIntfExceptions.cpp \
		  TestIntfExceptions.h \
		  TestIntfExceptions_skel.cpp \
		  TestIntfExceptions_skel.h \
		  TestIntfExceptions_skel_tie.h \
		  TestIntfExceptionsExt_2_0.cpp \
		  TestIntfExceptionsExt_2_0.h \
		  TestIntfExceptionsExt_2_0_skel.cpp \
		  TestIntfExceptionsExt_2_0_skel.h \
		  TestIntfExceptionsExt_2_0_skel_tie.h \
		  TestIntfWChar.cpp \
		  TestIntfWChar.h \
		  TestIntfWChar_skel.cpp \
		  TestIntfWChar_skel.h \
		  TestIntfWChar_skel_tie.h \
		  TestIntfFixed.cpp \
		  TestIntfFixed.h \
		  TestIntfFixed_skel.cpp \
		  TestIntfFixed_skel.h \
		  TestIntfFixed_skel_tie.h \
		  TestIntfLongDouble.cpp \
		  TestIntfLongDouble.h \
		  TestIntfLongDouble_skel.cpp \
		  TestIntfLongDouble_skel.h \
		  TestIntfLongDouble_skel_tie.h \
		  TestIntfLongLong.cpp \
		  TestIntfLongLong.h \
		  TestIntfLongLong_skel.cpp \
		  TestIntfLongLong_skel.h \
		  TestIntfLongLong_skel_tie.h \
		  TestIntfExceptionsExt_2_3.cpp \
		  TestIntfExceptionsExt_2_3.h \
		  TestIntfExceptionsExt_2_3_skel.cpp \
		  TestIntfExceptionsExt_2_3_skel.h \
		  TestIntfExceptionsExt_2_3_skel_tie.h \
		  TestIntfStubTimeout.cpp \
		  TestIntfStubTimeout.h \
		  TestIntfStubTimeout_skel.cpp \
		  TestIntfStubTimeout_skel.h \
		  TestIntfStubTimeout_skel_tie.h

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)
ALL_CPPFLAGS	= /I. /I..\include $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	-del $@
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERVER_NAME): $(SERVER_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(SERVER_OBJS) $(ALL_LIBS)

$(CLIENT_NAME): $(CLIENT_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(CLIENT_OBJS) $(ALL_LIBS)

$(COLLOCATED_NAME): $(COLLOCATED_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(COLLOCATED_OBJS) $(ALL_LIBS)

TestIntfStubTimeout.cpp \
TestIntfStubTimeout.h: TestIntfStubTimeout.idl
	-del TestIntfStubTimeout.cpp TestIntfStubTimeout.h
	$(IDL) --tie TestIntfStubTimeout.idl

TestIntfStubTimeout_skel.cpp \
TestIntfStubTimeout_skel.h \
TestIntfStubTimeout_tie.h \
TestIntfStubTimeout_skel_tie.h:
	TestIntfStubTimeout.cpp

TestIntfExceptionsExt_2_3.cpp \
TestIntfExceptionsExt_2_3.h: TestIntfExceptionsExt_2_3.idl
	-del TestIntfExceptionsExt_2_3.cpp TestIntfExceptionsExt_2_3.h
	$(IDL) --tie TestIntfExceptionsExt_2_3.idl

TestIntfExceptionsExt_2_3_skel.cpp \
TestIntfExceptionsExt_2_3_skel.h \
TestIntfExceptionsExt_2_3_tie.h \
TestIntfExceptionsExt_2_3_skel_tie.h:
	TestIntfExceptionsExt_2_3.cpp

TestIntfLongLong.cpp \
TestIntfLongLong.h: TestIntfLongLong.idl
	-del TestIntfLongLong.cpp TestIntfLongLong.h
	$(IDL) --tie TestIntfLongLong.idl

TestIntfLongLong_skel.cpp \
TestIntfLongLong_skel.h \
TestIntfLongLong_tie.h \
TestIntfLongLong_skel_tie.h:
	TestIntfLongLong.cpp

TestIntfLongDouble.cpp \
TestIntfLongDouble.h: TestIntfLongDouble.idl
	-del TestIntfLongDouble.cpp TestIntfLongDouble.h
	$(IDL) --tie TestIntfLongDouble.idl

TestIntfLongDouble_skel.cpp \
TestIntfLongDouble_skel.h \
TestIntfLongDouble_tie.h \
TestIntfLongDouble_skel_tie.h:
	TestIntfLongDouble.cpp

TestIntfFixed.cpp TestIntfFixed.h: TestIntfFixed.idl
	-del TestIntfFixed.cpp TestIntfFixed.h
	$(IDL) --tie TestIntfFixed.idl

TestIntfFixed_skel.cpp \
TestIntfFixed_skel.h \
TestIntfFixed_tie.h \
TestIntfFixed_skel_tie.h: 
	TestIntfFixed.cpp

TestIntfWChar.cpp TestIntfWChar.h: TestIntfWChar.idl
	-del TestIntfWChar.cpp TestIntfWChar.h
	$(IDL) --tie TestIntfWChar.idl

TestIntfWChar_skel.cpp \
TestIntfWChar_skel.h \
TestIntfWChar_tie.h \
TestIntfWChar_skel_tie.h: 
	TestIntfWChar.cpp

TestIntfExceptionsExt_2_0.cpp \
TestIntfExceptionsExt_2_0.h: TestIntfExceptionsExt_2_0.idl
	-del TestIntfExceptionsExt_2_0.cpp TestIntfExceptionsExt_2_0.h
	$(IDL) --tie TestIntfExceptionsExt_2_0.idl

TestIntfExceptionsExt_2_0_skel.cpp \
TestIntfExceptionsExt_2_0_skel.h \
TestIntfExceptionsExt_2_0_tie.h \
TestIntfExceptionsExt_2_0_skel_tie.h: 
	TestIntfExceptionsExt_2_0.cpp

TestIntfExceptions.cpp \
TestIntfExceptions.h: TestIntfExceptions.idl
	-del TestIntfExceptions.cpp TestIntfExceptions.h
	$(IDL) --tie TestIntfExceptions.idl

TestIntfExceptions_skel.cpp \
TestIntfExceptions_skel.h \
TestIntfExceptions_tie.h \
TestIntfExceptions_skel_tie.h: 
	TestIntfExceptions.cpp

TestIntfContext.cpp TestIntfContext.h: TestIntfContext.idl
	-del TestIntfContext.cpp TestIntfContext.h
	$(IDL) --tie TestIntfContext.idl

TestIntfContext_skel.cpp \
TestIntfContext_skel.h \
TestIntfContext_tie.h \
TestIntfContext_skel_tie.h: 
	TestIntfContext.cpp

TestIntfBasic.cpp TestIntfBasic.h: TestIntfBasic.idl
	-del TestIntfBasic.cpp TestIntfBasic.h
	$(IDL) --tie TestIntfBasic.idl

TestIntfBasic_skel.cpp \
TestIntfBasic_skel.h \
TestIntfBasic_tie.h \
TestIntfBasic_skel_tie.h: 
	TestIntfBasic.cpp

TestIntf.cpp TestIntf.h: TestIntf.idl
	-del TestIntf.cpp TestIntf.h
	$(IDL) --tie TestIntf.idl

TestIntf_skel.cpp TestIntf_skel.h TestIntf_tie.h TestIntf_skel_tie.h: 
	TestIntf.cpp
!ifndef BUILD_EXE
install:: all

$(EVERYTHING)::
	$(MAKE) /f Makefile.mak BUILD_EXE=1 $@
!else
install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
!endif


!include .windep
