// **********************************************************************
//
// Copyright (c) 2001
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <TestIntfFixed_impl.h>

#include <limits.h>

#ifdef HAVE_UNISTD_H
#   include <unistd.h>
#endif

using namespace CORBA;

TestIntfFixed_impl::TestIntfFixed_impl()
{
}

void
TestIntfFixed_impl::attrFixed(
    const ORBTest_Fixed::TestFixed& val
)
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aFixed = val;
}

ORBTest_Fixed::TestFixed
TestIntfFixed_impl::attrFixed()
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    return m_aFixed;
}


ORBTest_Fixed::TestFixed
TestIntfFixed_impl::opFixed(
    const ORBTest_Fixed::TestFixed& a0,
    ORBTest_Fixed::TestFixed& a1,
    ORBTest_Fixed::TestFixed_out a2
)
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aFixed = a0 + a1;
    a1 = a2 = m_aFixed;
    return m_aFixed;
}

ORBTest_Fixed::TestFixed
TestIntfFixed_impl::opFixedEx(
    const ORBTest_Fixed::TestFixed& a0,
    ORBTest_Fixed::TestFixed& a1,
    ORBTest_Fixed::TestFixed_out
)
    throw (
	ORBTest_Fixed::ExFixed,
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aFixed = a0 + a1;
    throw ORBTest_Fixed::ExFixed(m_aFixed);
    return (Long)0; // Some compilers need this
}

