// **********************************************************************
//
// Copyright (c) 2001
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <TestIntfWChar_impl.h>

#include <limits.h>

#ifdef HAVE_UNISTD_H
#   include <unistd.h>
#endif

using namespace CORBA;

TestIntfWChar_impl::TestIntfWChar_impl()
{
}

WChar
TestIntfWChar_impl::attrWChar()
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    return m_aWChar;
}


void
TestIntfWChar_impl::attrWChar(
    WChar val
)
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aWChar = val;
}

WChar
TestIntfWChar_impl::opWChar(
    WChar a0,
    WChar& a1,
    WChar& a2
)
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aWChar = a0 + a1;
    a1 = a2 = m_aWChar;
    return m_aWChar;
}

WChar
TestIntfWChar_impl::opWCharEx(
    WChar a0,
    WChar& a1,
    WChar&
)
    throw (
	ORBTest_WChar::ExWChar,
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aWChar = a0 + a1;
    throw ORBTest_WChar::ExWChar(m_aWChar);
    return 0; // Some compilers need this
}

wchar_t*
TestIntfWChar_impl::attrWString()
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    return wstring_dup(m_aWString);
}

void
TestIntfWChar_impl::attrWString(
    const wchar_t* val
)
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aWString = val;
}

wchar_t*
TestIntfWChar_impl::opWString(
    const wchar_t* a0,
    wchar_t*& a1,
    WString_out a2
)
    throw (
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aWString = wstring_alloc(OB::wcslen(a0) + OB::wcslen(a1));
    OB::wcscpy(m_aWString.inout(), a0);
    OB::wcscat(m_aWString.inout(), a1);
    wstring_free(a1);
    a1 = wstring_dup(m_aWString);
    a2 = wstring_dup(m_aWString);
    return wstring_dup(m_aWString);
}

wchar_t*
TestIntfWChar_impl::opWStringEx(
    const wchar_t* a0,
    wchar_t*& a1,
    WString_out
)
    throw (
	ORBTest_WChar::ExWString,
	CORBA::SystemException
    )
{
    JTCSynchronized synchronized(*this);

    m_aWString = wstring_alloc(OB::wcslen(a0) + OB::wcslen(a1));
    OB::wcscpy(m_aWString.inout(), a0);
    OB::wcscat(m_aWString.inout(), a1);
    throw ORBTest_WChar::ExWString(m_aWString);
    return 0; // Some compilers need this
}
