// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <Multi_impl.h>

#ifdef HAVE_UNISTD_H
#   include <unistd.h>
#endif

#ifdef HAVE_PROCESS_H
#   include <process.h>
#endif

Multi_impl::Multi_impl(CORBA::ORB_ptr orb)
    : orb_(CORBA::ORB::_duplicate(orb))
{
}

void
Multi_impl::deactivate()
    throw(CORBA::SystemException)
{
    orb_ -> shutdown(false);
}

CORBA::ULong
Multi_impl::getpid()
    throw(CORBA::SystemException)
{
#ifdef WIN32
    return (CORBA::ULong)GetCurrentProcessId();
#elif defined(__linux__)
    return pid_;
#else
    return (CORBA::ULong)::getpid();
#endif
}
