// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <stdlib.h>

using namespace CORBA;

int
main(int argc, char* argv[], char*[])
{
    int status = EXIT_SUCCESS;
    ORB_var orb;

    try
    {
        void ClientRegisterInterceptors(bool);
        ClientRegisterInterceptors(true);

        void ServerRegisterInterceptors();
        ServerRegisterInterceptors();

        orb = ORB_init(argc, argv, "myORB");

        int ServerRun(ORB_ptr, bool, int, char*[]);
        status = ServerRun(orb, true, argc, argv);

        if(status == 0)
        {
            int ClientRun(ORB_ptr, bool, int, char*[]);
            status = ClientRun(orb, true, argc, argv);

	    //
	    // The ORB must be totally shutdown before the servants
	    // are deleted.
	    //
	    orb -> shutdown(true);
	    
            void ServerCleanup();
            ServerCleanup();
	    void ClientCleanup();
	    ClientCleanup();
        }
    }
    catch(const Exception& ex)
    {
	OB_ERROR(ex);
        status = EXIT_FAILURE;
    }

    if(!is_nil(orb))
    {
	try
	{
	    orb -> destroy();
	}
	catch(const Exception& ex)
	{
	    OB_ERROR(ex);
	    status = EXIT_FAILURE;
	}
    }

    return status;
}
