# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\obtestpi$(LIBSUFFIX).lib
PDB_NAME	= $(top_srcdir)\lib\obtestpi$(LIBSUFFIX).pdb
SERVER_NAME	= server.exe
CLIENT_NAME	= client.exe
COLLOCATED_NAME = collocated.exe

!ifndef BUILD_EXE
TARGETS		= $(LIB_NAME) 
PDB_FLAGS	= /Fd$(PDB_NAME)
!else
TARGETS		= $(SERVER_NAME) \
		  $(CLIENT_NAME) \
		  $(COLLOCATED_NAME)

PDB_FILES 	= $(TARGETS:.exe=.pdb) \
		  $(PDB_NAME)
!endif

!include $(top_srcdir)\config\Make.rules.mak

LIB_OBJS	= TestInterface.obj \
		  TestInterface_skel.obj \
		  TestPolicy.obj \
		  TestInterface_impl.obj \
		  TestInterfaceDSI_impl.obj \
		  ClientCommon.obj \
		  ServerCommon.obj \
		  TestCalls.obj \
		  TestCodec.obj \
		  TestTranslation.obj \
		  Server.obj \
		  Client.obj

SERVER_OBJS	= ServerMain.obj

CLIENT_OBJS	= ClientMain.obj

COLLOCATED_OBJS	= CollocatedMain.obj

SRCS		= $(LIB_OBJS:.obj=.cpp) \
		  $(SERVER_OBJS:.obj=.cpp) \
		  $(CLIENT_OBJS:.obj=.cpp)

GENERATED	= TestInterface.cpp \
		  TestInterface.h \
		  TestInterface_skel.cpp \
		  TestInterface_skel.h \
		  TestPolicy.cpp \
		  TestPolicy.h \
		  TestPolicy_skel.cpp \
		  TestPolicy_skel.h

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)
ALL_CPPFLAGS	= /I. /I..\include $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	-del $@
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERVER_NAME): $(SERVER_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(SERVER_OBJS) $(ALL_LIBS)

$(CLIENT_NAME): $(CLIENT_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(CLIENT_OBJS) $(ALL_LIBS)

$(COLLOCATED_NAME): $(COLLOCATED_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(COLLOCATED_OBJS) $(ALL_LIBS)

TestInterface.cpp TestInterface.h: TestInterface.idl
	-del TestInterface.cpp TestInterface.h
	-del TestInterface_skel.cpp TestInterface_skel.h
	$(IDL) -I$(top_srcdir)\idl --with-interceptor-args TestInterface.idl

TestInterface_skel.cpp TestInterface_skel.h: TestInterface.cpp

TestPolicy.cpp TestPolicy.h: TestPolicy.idl
	-del TestPolicy.cpp TestPolicy.h
	$(IDL) -I$(top_srcdir)\idl -I$(top_srcdir)\idl\OB TestPolicy.idl

TestPolicy_skel.cpp TestPolicy_skel.h : TestPolicy.cpp

!ifndef BUILD_EXE
install:: all

$(EVERYTHING)::
	$(MAKE) /f Makefile.mak BUILD_EXE=1 $@
!else
install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
!endif

!include .windep
