// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <stdlib.h>

#ifdef TEST_X11_REACTOR
#   include <X11/Intrinsic.h>
#   include <OB/X11.h>
#endif

using namespace CORBA;

int
main(int argc, char* argv[], char*[])
{
    int status = EXIT_SUCCESS;
    ORB_var orb;

    try
    {
#ifdef TEST_X11_REACTOR
	XtAppContext appContext;
	Widget topLevel = XtAppInitialize(&appContext, "Test", 0, 0,
					  &argc, argv, 0, 0, 0);
	OB::X11Init(appContext);
#endif

        void ServerRegisterInterceptors();
        ServerRegisterInterceptors();

        orb = ORB_init(argc, argv, "myORB");
	int ServerRun(ORB_ptr, bool, int, char*[]);
	status = ServerRun(orb, false, argc, argv);
    }
    catch(const Exception& ex)
    {
	OB_ERROR(ex);
	status = EXIT_FAILURE;
    }

    if(!is_nil(orb))
    {
	try
	{
	    orb -> destroy();
	}
	catch(const Exception& ex)
	{
	    OB_ERROR(ex);
	    status = EXIT_FAILURE;
	}
    }

    return status;
}
