# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME        = $(top_srcdir)\lib\obtestpoa$(LIBSUFFIX).lib
PDB_NAME        = $(top_srcdir)\lib\obtestpoa$(LIBSUFFIX).pdb

!ifndef BUILD_EXE
TARGETS         = $(LIB_NAME)
PDB_FLAGS       = /Fd$(PDB_NAME)
!else
TARGETS		= TestActivate.exe \
		  TestDeactivate.exe \
		  TestAdapterActivatorServer.exe \
		  TestCollocated.exe \
		  TestCreate.exe \
		  TestDestroy.exe \
		  TestFind.exe \
		  TestMisc.exe \
		  TestRefCount.exe \
		  TestClient.exe \
		  TestServantActivatorServer.exe \
		  TestServantLocatorServer.exe \
		  TestLocationForwardClient.exe \
		  TestLocationForwardServer.exe \
		  TestDefaultServantServer.exe \
		  TestRefCountServer.exe \
		  TestPOAManagerServer.exe \
		  TestPOAManagerClient.exe  \
		  TestDispatchStrategyServer.exe \
		  TestDispatchStrategyClient.exe \
		  TestMultipleOrbsServer.exe \
		  TestMultipleOrbsClient.exe \
		  TestMultipleOrbsThreadedServer.exe \
		  TestMultipleOrbsThreadedClient.exe \

PDB_FILES      =  $(TARGETS:.exe=.pdb) \
		  $(PDB_NAME)
!endif

!include $(top_srcdir)\config\Make.rules.mak

LIB_OBJS        = Test.obj \
		  Test_skel.obj \
		  TestUtil.obj \
		  Test_impl.obj \
		  TestServer_impl.obj \
		  TestDSI_impl.obj \
		  TestDSIRef_impl.obj \
		  TestRef_impl.obj \
		  TestLocationForwardActivator.obj \
		  TestLocationForwardActivator_skel.obj \
		  TestLocationForwardActivator_impl.obj \
		  TestLocationForward_impl.obj \
		  POAManagerProxy.obj \
		  POAManagerProxy_skel.obj \
		  TestPOAManagerCommon.obj

GENERATED	= Test.cpp \
		  Test.h \
		  Test_skel.cpp \
		  Test_skel.h \
		  TestLocationForwardActivator.cpp \
		  TestLocationForwardActivator.h \
		  TestLocationForwardActivator_skel.cpp \
		  TestLocationForwardActivator_skel.h \
		  POAManagerProxy.cpp \
		  POAManagerProxy.h \
		  POAManagerProxy_skel.cpp \
		  POAManagerProxy_skel.h

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)
ALL_CPPFLAGS	= /I. /I..\include $(OB_CPPFLAGS) $(CPPFLAGS) 
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	-del $@
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

TestActivate.exe: TestActivate.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestDeactivate.exe: TestDeactivate.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestCollocated.exe: TestCollocated.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestCreate.exe: TestCreate.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestFind.exe: TestFind.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestAdapterActivatorServer.exe: TestAdapterActivatorServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestDestroy.exe: TestDestroy.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestMisc.exe: TestMisc.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestRefCount.exe: TestRefCount.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestClient.exe: TestClient.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestServantActivatorServer.exe: TestServantActivatorServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestServantLocatorServer.exe: TestServantLocatorServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestDefaultServantServer.exe: TestDefaultServantServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestRefCountServer.exe: TestRefCountServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestLocationForwardClient.exe: TestLocationForwardClient.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestLocationForwardServer.exe: TestLocationForwardServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestPOAManagerServer.exe: TestPOAManagerServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestPOAManagerClient.exe: TestPOAManagerClient.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestDispatchStrategyServer.exe: TestDispatchStrategyServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestDispatchStrategyClient.exe: TestDispatchStrategyClient.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestMultipleOrbsServer.exe: TestMultipleOrbsServer.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestMultipleOrbsClient.exe: TestMultipleOrbsClient.obj $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestMultipleOrbsThreadedServer.exe: TestMultipleOrbsThreadedServer.obj \
        $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestMultipleOrbsThreadedClient.exe: TestMultipleOrbsThreadedClient.obj \
        $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

Test.cpp Test.h: Test.idl
	-del Test.cpp Test.h
	-del Test_skel.cpp Test_skel.h
	$(IDL) --no-type-codes Test.idl

Test_skel.cpp Test_skel.h : Test.cpp

TestLocationForwardActivator.cpp TestLocationForwardActivator.h: \
	TestLocationForwardActivator.idl
	-del TestLocationForwardActivator.cpp TestLocationForwardActivator.h
	-del TestLocationForwardActivator_skel.cpp
	-del TestLocationForwardActivator.h
	$(IDL) -I$(IDLDIR) -I. --no-type-codes \
	TestLocationForwardActivator.idl

TestLocationForwardActivator_skel.cpp TestLocationForwardActivator_skel.h : \
	TestLocationForwardActivator.cpp

POAManagerProxy.cpp POAManagerProxy.h: POAManagerProxy.idl
	-del POAManagerProxy.cpp POAManagerProxy.h
	-del POAManagerProxy_skel.cpp POAManagerProxy_skel.h
	$(IDL) --no-type-codes POAManagerProxy.idl

POAManagerProxy_skel.cpp POAManagerProxy_skel.h : POAManagerProxy.cpp

!ifndef BUILD_EXE
install:: all

install all test clean::
	$(MAKE) /f Makefile.mak BUILD_EXE=1 $@
!else
install::
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
!endif

!include .windep
