// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef _Test_impl_h_
#define _Test_impl_h_

#include <Test_skel.h>

class Test_impl : virtual public POA_Test,
                  virtual public PortableServer::RefCountServantBase
{
    Test_impl(const Test_impl&);
    void operator=(const Test_impl&);

public:

    Test_impl();
    ~Test_impl();

    virtual void aMethod()
        throw(CORBA::SystemException);
};

class Retry_impl : public POA_Retry,
                   public PortableServer::RefCountServantBase
{
    Retry_impl(const Retry_impl&);
    void operator=(const Retry_impl&);

    CORBA::ULong count_;
    CORBA::ULong max_;
    CORBA::Boolean maybe_;

public:

    Retry_impl();
    ~Retry_impl();

    virtual void aMethod()
        throw(CORBA::SystemException);

    virtual CORBA::ULong get_count()
        throw(CORBA::SystemException);

    virtual void raise_exception(CORBA::ULong, CORBA::Boolean)
        throw(CORBA::SystemException);
};

class RetryServer_impl : public POA_RetryServer,
                         public PortableServer::RefCountServantBase
{
    RetryServer_impl(const RetryServer_impl&);
    void operator=(const RetryServer_impl&);

    CORBA::ORB_var orb_;
    Test_var test_;
    Retry_var retry_;

public:

    RetryServer_impl(CORBA::ORB_ptr, Test_ptr, Retry_ptr);
    ~RetryServer_impl();

    virtual Test_ptr get_location_forward_object()
        throw(CORBA::SystemException);

    virtual Retry_ptr get_retry_object()
        throw(CORBA::SystemException);

    virtual void deactivate()
        throw(CORBA::SystemException);
};

#endif
