# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\obtesttypes$(LIBSUFFIX).lib
PDB_NAME	= $(top_srcdir)\lib\obtesttypes$(LIBSUFFIX).pdb

!ifndef BUILD_EXE
TARGETS		= $(LIB_NAME)
PDB_FLAGS	= /Fd$(PDB_NAME)
!else
TARGETS		= TestConst.exe \
		  TestTypeCode.exe \
		  TestAny.exe \
		  TestDynAny.exe \
		  TestUnion.exe \
		  TestFixed.exe \
		  TestSequence.exe \

PDB_FILES	= $(TARGETS:.exe=.pdb) \
		  $(PDB_NAME)
!endif

!include $(top_srcdir)\config\Make.rules.mak

LIB_OBJS	= Types.obj \
		  Constants.obj \
		  DynAnyTypes.obj

GENERATED	= Types.cpp \
		  Types.h \
		  Constants.cpp \
		  Constants.h \
		  DynAnyTypes.cpp \
		  DynAnyTypes.h

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. /I..\include /I$(top_srcdir)\include\OB $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	-del $@
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

Types.cpp Types.h: Types.idl
	-del Types.cpp Types.h
	$(IDL) -I$(top_srcdir)/idl/OB --no-skeletons Types.idl

Constants.cpp Constants.h: Constants.idl
	-del Constants.cpp Constants.h
	$(IDL) --no-skeletons --no-type-codes Constants.idl

DynAnyTypes.cpp DynAnyTypes.h: DynAnyTypes.idl
	-del DynAnyTypes.cpp DynAnyTypes.h
	$(IDL) -I$(top_srcdir)/idl/OB --no-skeletons DynAnyTypes.idl

TestConst.exe: TestConst.obj $(LIB_NAME)
        -del $@
        $(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestTypeCode.exe: TestTypeCode.obj $(LIB_NAME)
        -del $@
        $(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestAny.exe: TestAny.obj $(LIB_NAME)
        -del $@
        $(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestDynAny.exe: TestDynAny.obj $(LIB_NAME)
        -del $@
        $(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestUnion.exe: TestUnion.obj $(LIB_NAME)
        -del $@
        $(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestFixed.exe: TestFixed.obj $(LIB_NAME)
        -del $@
        $(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

TestSequence.exe: TestSequence.obj $(LIB_NAME)
        -del $@
        $(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(ALL_LIBS)

!ifndef BUILD_EXE
install:: all

install all test clean::
	$(MAKE) /f Makefile.mak BUILD_EXE=1 $@
!else
install:: Types.obj
!endif

!include .windep
