# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

LIB_NAME	= $(top_srcdir)\lib\CosProperty$(LIBSUFFIX).lib
PDB_NAME        = $(top_srcdir)\lib\CosProperty$(LIBSUFFIX).pdb

SERVER_NAME	= $(top_srcdir)\bin\propserv.exe

!ifndef BUILD_UTILS

PDB_FLAGS       = /Fd$(PDB_NAME)
TARGETS		= $(LIB_NAME)

!else

TARGETS 	= $(SERVER_NAME) 
PDB_FILES	= $(TARGETS:.exe=.pdb) \
		  $(PDB_NAME)

!endif

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl\OB
HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= CosProperty.obj \
		  CosProperty_skel.obj \
		  CosProperty_impl.obj

COMMON_OBJS	=

CLIENT_OBJS	=

SERVER_OBJS	= CosProperty_impl.obj \
		  Server.obj

DEF_NAME = CosProperty$(LIBSUFFIX).def
DLL_NAME = $(top_srcdir)\lib\CosProperty$(OB_LIBVER)$(LIBSUFFIX).dll
EXP_NAME = $(top_srcdir)\lib\CosProperty$(LIBSUFFIX).exp

!ifndef BUILD_UTILS
ALL_CPPFLAGS    = /DOB_PROPERTY_IMPORT=/**/ /I. /I$(top_srcdir)\include \
                  $(OB_CPPFLAGS) $(CPPFLAGS)
!else
ALL_CPPFLAGS    = /I. /I$(top_srcdir)\include $(OB_CPPFLAGS) $(CPPFLAGS)
!endif


ALL_CXXFLAGS    = $(CXXFLAGS)
ALL_LIBS        = $(LIB_NAME) $(OB_LIBS) $(LIBS)

!if "$(DLL)" == "yes"

ALL_DLLLIBS     = $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(LIB_NAME): $(DLL_NAME)

$(DEF_NAME):

$(DLL_NAME): $(LIB_OBJS) $(DEF_NAME)
        perl $(top_srcdir)\..\config\makedef.pl $(DEF_NAME) \
        CosProperty$(OB_LIBVER)$(LIBSUFFIX) $(LIB_OBJS)
        $(LINK) $(LINKDLLFLAGS) /BASE:0x52000000 /def:$(DEF_NAME) \
        /IMPLIB:$(LIB_NAME) /out:$@ $(LIB_OBJS) $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS    = $(CXXFLAGS) $(PDB_FLAGS)

$(LIB_NAME): $(LIB_OBJS)
        -del $@
        $(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

!endif

$(SERVER_NAME): $(COMMON_OBJS) $(SERVER_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(SERVER_OBJS) $(ALL_LIBS)
 
CosProperty.cpp $(HDIR)\CosProperty.h: $(IDLDIR)\CosProperty.idl
	-del CosProperty.cpp
	-del $(HDIR)\CosProperty.h
	-del CosProperty_skel.cpp
	-del $(HDIR)\CosProperty_skel.h
	$(IDL) -I$(IDLDIR) --header-dir OB \
	--dll-import OB_PROPERTY_IMPORT $(IDLDIR)\CosProperty.idl
	move CosProperty.h $(HDIR)
	move CosProperty_skel.h $(HDIR)

CosProperty_skel.cpp $(HDIR)\CosProperty_skel.h: CosProperty.cpp

Config.h:
	echo /* dummy file */ > $@

!ifndef BUILD_UTILS

install:: all

min:: all

install_min:: install

$(EVERYTHING)::
	$(MAKE) /f Makefile.mak BUILD_UTILS=1 $@

!else

install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
	copy $(SERVER_NAME) $(bindir)

!if "$(DLL)" == "yes"

DLL_PDB = $(DLL_NAME:.dll=.pdb)

install:: all
        copy $(DLL_NAME) $(libdir)
        copy $(EXP_NAME) $(libdir)
        if exist $(DLL_PDB) copy $(DLL_PDB) $(libdir)

!endif

clean::
        -del $(DLL_NAME) $(EXP_NAME) $(DEF_NAME) $(DLL_NAME:.dll=.pdb)

min:: all

install_min:: install

!endif

!include .windep
