# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

LIB_NAME	= $(top_srcdir)\lib\CosTime$(LIBSUFFIX).lib
LIB_PDB_NAME	= $(top_srcdir)\lib\CosTime$(LIBSUFFIX).pdb

PDB_FILES	= $(LIB_PDB_NAME)

PDB_FLAGS	= /Fd$(LIB_PDB_NAME)
TARGETS		= $(LIB_NAME)

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl\OB
HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= CosTime.obj \
                  CosTime_impl.obj \
		  TimeService.obj

# Also in non-DLL mode needed for clean target.
DEF_NAME	= CosTime$(LIBSUFFIX).def
DLL_NAME        = $(top_srcdir)\lib\CosTime$(OB_LIBVER)$(LIBSUFFIX).dll
EXP_NAME        = $(top_srcdir)\lib\CosTime$(LIBSUFFIX).exp

ALL_CPPFLAGS	= /DOB_TIME_IMPORT=/**/ /I. /I$(top_srcdir)\include \
		  $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_IDLFLAGS	= -I$(IDLDIR) $(OB_IDLFLAGS)

!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS) 

ALL_DLLLIBS	= $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(LIB_NAME): $(DLL_NAME)

$(DEF_NAME):

$(DLL_NAME): $(LIB_OBJS) $(DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(DEF_NAME) \
	CosTime$(OB_LIBVER)$(LIBSUFFIX) $(LIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x56A00000 /def:$(DEF_NAME) \
	/IMPLIB:$(LIB_NAME) /out:$@ $(LIB_OBJS) $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)

$(LIB_NAME): $(LIB_OBJS)
	-del $@
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

!endif

CosTime.cpp $(HDIR)\CosTime.h: $(IDLDIR)\CosTime.idl
	-del CosTime.cpp $(HDIR)\CosTime.h
	$(IDL) $(ALL_IDLFLAGS) --this-header-dir OB --no-type-codes \
	--dll-import OB_TIME_IMPORT $(IDLDIR)\CosTime.idl
	move CosTime.h $(HDIR)

Config.h:
	echo /* dummy file */ > $@

install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(LIB_PDB_NAME) \
	copy $(LIB_PDB_NAME) $(libdir)

!if "$(DLL)" == "yes"

DLL_PDB = $(DLL_NAME:.dll=.pdb)

install:: all
	copy $(DLL_NAME) $(libdir)
	copy $(EXP_NAME) $(libdir)
	if exist $(DLL_PDB) copy $(DLL_PDB) $(libdir)

!endif

clean::
	-del $(DLL_NAME) $(EXP_NAME) $(DEF_NAME) $(DLL_NAME:.dll=.pdb)

min:: all

install_min:: install

!include .windep
