// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <Peer_impl.h>

#ifndef WIN32
# include <unistd.h>
#endif

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

// ----------------------------------------------------------------------
// Peer_impl constructor
// ----------------------------------------------------------------------

Peer_impl::Peer_impl(PortableServer::POA_ptr poa)
    : poa_(PortableServer::POA::_duplicate(poa))
{
}

// ----------------------------------------------------------------------
// Peer_impl public member implementation
// ----------------------------------------------------------------------

void
Peer_impl::decrement(CORBA::Long& value, Peer_ptr peer)
    throw(CORBA::SystemException)
{
    cout << value << endl;

    value--;

    //
    // Delay
    //
    JTCThread::sleep(100);

    if(value > 0)
    {
	Peer_var self = _this();

	try
	{
	    peer -> decrement(value, self);
	}
	catch(const CORBA::Exception& ex)
	{
	    cerr << "Got exception while calling `peer -> decrement()':"
		 << endl;
	    cerr << ex << endl;
	}
    }
}

PortableServer::POA_ptr
Peer_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(poa_);
}
