// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// *********************************************************************

#ifndef __OB_LoadAlert_impl_h__
#define __OB_LoadAlert_impl_h__

#include <OB/LocalObject.h>
#include <OB/BalancerUtil.h>

//
// IDL:ooc.com/LoadBalancing:1.0
//
namespace LoadBalancing
{

//
// IDL:ooc.com/LoadBalancing/Util:1.0
//
namespace Util
{

//
// Forward declaration
//
class LoadAlertInterceptor;

//
// IDL:ooc.com/LoadBalancing/LoadAlert:1.0
//
class LoadAlert_impl : public LoadAlert,
		       public OBCORBA::RefCountLocalObject
{
    LoadAlert_impl(const LoadAlert_impl&);
    void operator=(const LoadAlert_impl&);

    //
    // The LoadAlertInterceptor
    //
    LoadAlertInterceptor* interceptor_;

public:

    LoadAlert_impl(LoadAlertInterceptor*);
    virtual ~LoadAlert_impl();

    //
    // IDL:ooc.com/LoadBalancing/Util/LoadAlert/alert:1.0
    //
    virtual void alert()
        throw(CORBA::SystemException);

    //
    // IDL:ooc.com/LoadBalancing/Util/LoadAlert/get_alert_expire:1.0
    //
    virtual CORBA::ULong get_alert_expire()
        throw(CORBA::SystemException);

    //
    // IDL:ooc.com/LoadBalancing/Util/LoadAlert/set_alert_expire:1.0
    //
    virtual void set_alert_expire(CORBA::ULong millis)
        throw(CORBA::SystemException);
};

} // End of namespace Util

} // End of namespace LoadBalancing

#endif
