// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_DISPATCH_REQUEST_IMPL_H
#define OB_DISPATCH_REQUEST_IMPL_H

#include <OB/Upcall_fwd.h>
#include <OB/POAServantBase_fwd.h>

#include <OB/NativeTypes.h>
#include <OB/MarshalStubImpl.h>
#include <OB/POAServantLocator.h>
#include <OB/LocalObject.h>

#include <OB/Dispatch.h>

//
// Forward declaration
//
namespace OBPortableServer
{

class POA_impl;

} // End namespace OBPortableServer

namespace OB
{

class DispatchRequest_impl : public DispatchRequest,
			     public OBCORBA::RefCountLocalObject
{
    DispatchRequest_impl(const DispatchRequest_impl&);
    void operator=(const DispatchRequest_impl&);

protected:

    //
    // The POA
    //
    PortableServer::POA_var poaDummy_;
    OBPortableServer::POA_impl* poa_;

    //
    // The ObjectId
    //
    PortableServer::ObjectId oid_;

    //
    // The Upcall
    //
    OB::Upcall_var upcall_;
    
public:
    
    DispatchRequest_impl(OBPortableServer::POA_impl*,
			 const PortableServer::ObjectId&,
			 OB::Upcall_ptr);
	
    ~DispatchRequest_impl();
    
    //
    // IDL:ooc.com/OB/DispatchRequest/invoke:1.0
    //
    virtual void
    invoke();
};

} // End of namespace OB

#endif
