// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_LOGGER_IMPL_H
#define OB_LOGGER_IMPL_H

#include <OB/LocalObject.h>
#include <OB/Logger.h>

namespace OB
{

//
// The logger implementation class
//
class Logger_impl : public WLogger,
		    public OBCORBA::RefCountLocalObject,
		    public JTCMutex
{
    //
    // Hide copy-constructor and assignment operator
    //
    Logger_impl(const Logger_impl&);
    void operator=(const Logger_impl&);

    virtual void message(const char*);
    virtual void wmessage(const wchar_t*);

public:

    Logger_impl();
    virtual ~Logger_impl();

    //
    // IDL to C++ mapping
    //
    virtual void info(const char*);
    virtual void error(const char*);
    virtual void warning(const char*);
    virtual void trace(const char*, const char*);
    virtual void winfo(const wchar_t*);
    virtual void werror(const wchar_t*);
    virtual void wwarning(const wchar_t*);
    virtual void wtrace(const wchar_t*, const wchar_t*);
};

} // End of namespace OB

#endif
