// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_PI_CURRENT_IMPL_H
#define OB_PI_CURRENT_IMPL_H

#include <OB/LocalObject.h>
#include <OB/TypeCode.h>
#include <OB/PICurrent.h>

namespace PortableInterceptor
{

//
// Forward declaration
//
struct SlotDataHolder;

//
// Implementation of PortableInterceptor::Current
//
class Current_impl : public Current,
		     public OBCORBA::RefCountLocalObject
{
    //
    // Hide copy constructor/assignment operator
    //
    Current_impl(const Current_impl&);
    void operator=(const Current_impl&);

    JTCThreadKey stateKey_;
    
    CORBA::ULong maxSlots_;

    SlotDataHolder* establishTSD(bool);

public:

    Current_impl();
    ~Current_impl();

    //
    // IDL to C++ Mapping
    //
    virtual CORBA::Any* get_slot(SlotId)
	throw(CORBA::SystemException, PortableInterceptor::InvalidSlot);

    virtual void set_slot(SlotId, const CORBA::Any&)
	throw(CORBA::SystemException, PortableInterceptor::InvalidSlot);

    CORBA::AnySeq* _OB_currentSlotData();

    void _OB_pushSlotData(CORBA::AnySeq&);
    void _OB_popSlotData();

    CORBA::AnySeq* _OB_newSlotTable() const;

    void _OB_setMaxSlots(CORBA::ULong);
};

} // End of namespace PortableInterceptor

#endif
