// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_POA_CURRENT_IMPL_H
#define OB_POA_CURRENT_IMPL_H

#include <OB/NativeTypes.h>
#include <OB/LocalObject.h>
#include <OB/POACurrent.h>
#include <OB/MarshalStubImpl.h>
#include <OB/POAServantLocator.h>

namespace PortableServer
{

//
// Forward declaration
//
class POACurrentState;

//
// The PortableServer::Current_impl class
//
class Current_impl : public Current,
		     public OBCORBA::RefCountLocalObject
{
    JTCThreadKey stateKey_;

public:

    Current_impl();
    ~Current_impl();

    //
    // IDL:omg.org/PortableServer/Current/get_POA:1.0
    //
    virtual POA_ptr get_POA()
        throw(Current::NoContext,
              CORBA::SystemException);

    //
    // IDL:omg.org/PortableServer/Current/get_object_id:1.0
    //
    virtual ObjectId* get_object_id()
        throw(Current::NoContext,
              CORBA::SystemException);

    //
    // IDL:omg.org/PortableServer/Current/get_reference:1.0
    //
    virtual CORBA::Object_ptr get_reference()
        throw(Current::NoContext,
              CORBA::SystemException);

    //
    // IDL:omg.org/PortableServer/Current/get_servant:1.0
    //
    virtual Servant get_servant()
	throw(Current::NoContext,
              CORBA::SystemException);

    //
    // ORBacus internal methods.
    //
    void _OB_preinvoke(POA_ptr,
                       ServantBase*,
		       const char*,
                       const ObjectId&,
                       ServantLocator::Cookie cookie);
    
    void _OB_postinvoke();

    bool _OB_inUpcall() const;
        
    ServantBase* _OB_getServant();
        
    ServantLocator::Cookie _OB_getCookie();

    const ObjectId& _OB_getObjectId();

    const char* _OB_getOp();
};

} // End of namespace PortableServer

#endif
