// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_UNKNOWN_EXCEPTION_IMPL_H
#define OB_UNKNOWN_EXCEPTION_IMPL_H

#include <OB/LocalObject.h>
#include <OB/OBORB_fwd.h>
#include <OB/UnknownException.h>

namespace OB
{

class UnknownExceptionInfo_impl : public UnknownExceptionInfo,
                                  public OBCORBA::RefCountLocalObject
{
    //
    // Hide copy-constructor and assignment operator
    //
    UnknownExceptionInfo_impl(const UnknownExceptionInfo_impl&);
    void operator=(const UnknownExceptionInfo_impl&);

    CORBA::String_var operation_;
    bool responseExpected_;
    OCI::TransportInfo_var transportInfo_;

public:

    UnknownExceptionInfo_impl(const char*, bool, OCI::TransportInfo_ptr);
    ~UnknownExceptionInfo_impl();

    //
    // IDL to C++ mapping
    //
    virtual char* operation();

    virtual CORBA::Boolean response_expected();

    virtual OCI::TransportInfo_ptr transport_info();

    virtual char* describe_exception();

    virtual void raise_exception();
};

class UnknownExceptionStrategy_impl : public UnknownExceptionStrategy,
                                      public OBCORBA::RefCountLocalObject
{
    //
    // Hide copy-constructor and assignment operator
    //
    UnknownExceptionStrategy_impl(const UnknownExceptionStrategy_impl&);
    void operator=(const UnknownExceptionStrategy_impl&);

protected:

    OBCORBA::ORB_var orb_;

public:

    UnknownExceptionStrategy_impl(OBCORBA::ORB_ptr);
    ~UnknownExceptionStrategy_impl();

    //
    // IDL to C++ mapping
    //
    virtual void unknown_exception(OB::UnknownExceptionInfo_ptr);

    virtual void destroy();
};

} // End of namespace OB

#endif
