// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_RIORBINITIALIZER_IMPL_H
#define OB_RIORBINITIALIZER_IMPL_H

#include <OB/CORBA.h>
#include <OB/PortableInterceptor.h>
#include <OB/LocalObject.h>
#include <OB/Logger.h>

namespace OB
{

//
// ORB Initializer for the server and client request interceptors
//
class RIORBInitializer_impl : public PortableInterceptor::ORBInitializer,
			      public OBCORBA::RefCountLocalObject
{
    // 
    // Logging levels
    //
    CORBA::Long logLevelIn_;
    CORBA::Long logLevelOut_;

    // 
    // Properties from ORB configuration
    //
    Properties_var properties_;

    // 
    // The ORBs Logger
    //
    WLogger_var logger_;

public:

    // 
    // Constructor/Destructor
    //
    RIORBInitializer_impl();
    ~RIORBInitializer_impl();

    //
    // IDL to C++ Mapping
    //
    virtual void
    pre_init(PortableInterceptor::ORBInitInfo_ptr);

    //
    // Note: the interceptors are registered in post_init()
    //       because the CRILogger_impl and SRILogger_impl
    //       constructors require
    //       ORBInitInfo::resolve_initial_reference(), which
    //       cannot be called in pre_init().
    //
    virtual void
    post_init(PortableInterceptor::ORBInitInfo_ptr);

};

} // End of namespace OB

#endif // OB_RIORBINITIALIZER_IMPL_H

